/* --------------------------------------------------------------
    Miller strong probable primality test.

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2003 by Dr. Raul N.Shakirov, IMach of RAS(UB).
    All Rights Reserved.

    Permission has been granted to copy, distribute and modify
    software in any context without fee, including a commercial
    application, provided that the aforesaid copyright statement
    is present here as well as exhaustive description of changes.

    THE SOFTWARE IS DISTRIBUTED "AS IS". NO WARRANTY OF ANY KIND
    IS EXPRESSED OR IMPLIED. YOU USE AT YOUR OWN RISK. THE AUTHOR
    WILL NOT BE LIABLE FOR DATA LOSS, DAMAGES, LOSS OF PROFITS OR
    ANY OTHER KIND OF LOSS WHILE USING OR MISUSING THIS SOFTWARE.
-------------------------------------------------------------- */
#ifdef  _MSC_VER
#pragma warning(disable:4995)
#endif/*_MSC_VER*/
#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>
#include "Cbignum.h"
#include "Gettimer.h"

int     main    (int argc, char **argv)
{
  cBigNumber num;
  if (argc > 1)
  {
    ifstream fin  (argv [1]);
    if (!fin)
    {
       cerr << "Can't read file " << argv [1] << endl;
       return 1;
    }
    fin >> dec >> num;
  }
  else
  {
    cerr <<"Please, type number to test for primality and press Enter\n";
    cin >> dec >> num;
    cerr <<"Thank you" << endl;
  }

  // Get number of increments by 2.

  int retcode = 0;
  long count = ((argc > 2)? atol (argv [2]): 1);
  if (count == 0) count = 1;

  // Compute,

  SetIdlePriority();
  long timer = GetTimer (0);
  for (; count > 0; count--, num += 2)
  {
    retcode |= IsPrime (num);
  }
  timer = GetTimer (timer);
  cout << endl <<"Time=" << setw (6) << timer << " mls" << endl;

  if (!cout)
  {
     cerr << "Write error" << endl;
     return 1;
  }

  return retcode;
}
