/*      exarray.h

	     
	  
	( ).
	http://www.imach.uran.ru/exarray

	(C) ..,   PAH, 1998 - 2000
	All Rights Reserved.
*/
//	  .

template <class T> class expoint;
template <class T> class exarray
{
  T*		e;	//  .
  unsigned	len;	//  .

//	    T
//	  , 
//	  .

  static  T*	stub ();

//	 .

  void 	realloc (unsigned size);

//	  
//	    i.

  void	grow	(unsigned i);

//	   
//	  ,
//	   
//	      
//	    .
//	    
//	  ,  
//	,    const T*.

  exarray		 (const exarray<T>&);
  exarray<T>& operator = (const exarray<T>&);

public:

//	  .
//	    
//	   , 
//	  len  0.
//	 e   stub() 
//	,  ""  
//	 .

  exarray ()		{ e = stub(); len = 0;	}

//	.

  ~exarray()		{ realloc (0);		}

//	     .
//	     
//	   ,
//	    :
//	1)     -
//	     abort().
//	2)   -  ,
//	     set_new_handler 
//	   new.h,     -  abort().
//	  ,
//	   , 
//	    T,  char,
//	   abort().
//	    
//	,      
//	   .

  T&    operator [] (unsigned i)
	{ if (len<=i) grow(i); return e[i];	}

  T&    operator [] (int i)
	{ return (operator [] ((unsigned) i));	}

  T&    operator *  ()
	{ if (len<=0) grow(0); return e[0];	}

//	     .
//	    
//	  .

  T&	item (unsigned i) { return (e [i]);	}
  T*	base ()		  { return (e);		}

//	   const T*
//	    
//	    const T*,  
//	  ,   -
//	    .
//	  ,   ,
//	  , 
//	 stub() -   
//	  exarray<char>  
//	 __src  strcpy  strcat.
//	  ,  
//	    
//	    C.
//	 ,   
//	 ,    
//	,   . 

  operator const T* ()	  { return (base());	}

//	 .

  expoint<T>  operator +  (unsigned i)
	{ return (expoint<T> (*this,  i));	}

  expoint<T>  operator +  (int i)
	{ return (expoint<T> (*this,  i));	}

  expoint<T>  operator -  (unsigned i)
	{ return (expoint<T> (*this, 0-i));	}

  expoint<T>  operator -  (int i)
	{ return (expoint<T> (*this, 0-i));	}
};

//	 exmrealloc , ,
//	    ,
//	 ,   
//	. . exarray.cpp.

void exmrealloc (void **p, unsigned size,
			   unsigned oldsize);

//	 excalcsize   
//	  ,    
//	 . . exarray.cpp.

unsigned excalcsize (unsigned size);

//	 exmuladd  
//	n * s + k,   
//	   int.
//	   ~0u.

inline unsigned exmuladd
	(unsigned s, unsigned n, unsigned k)
{
  return ((n <= ((~0u>>1)-k)/s)? (n*s+k): ~0u);
}

//	    
//	    .

template <class T> struct __EXRELOC
{
  T value;				
  void* operator new (size_t, void* p)
				 { return p;	}
  void  operator delete (void*)  { ; }
};

//	  stub  
//	   
//	,   T.

template <class T> T* exarray<T>::stub()
{
  static T _stub;
  return (&_stub);
}

//	  realloc 
//	    .
//	   
//	   
//	,     
//	  .

template <class T> void  exarray<T>::realloc
	 (unsigned size)
{
  unsigned n = size/sizeof (T);	//  .

  if (len == 0)
  {
//	    , 
//	   e.
    if (e == stub()) 
    {
//	 e   stub(),  
//	  e  .
      e = 0;
    }
    else
    {
//	   ""
//	 .
//	 size = ~0u 
//	  abort().
      if (e == 0) size = ~0u;
    }
  }

//	    .
  while (len > n)
	{ len--; delete (__EXRELOC<T> *) (e + len); }

//	 .
  ::exmrealloc ((void **)&e, size, sizeof(T) * len);

//	    .
  while (len < n)
	{ new (e + len)__EXRELOC<T>; len++; }

//	    
//	e   stub().
  if (e == 0) e = stub();
}

//	  grow  
//	     0  >= i,
//	  .

template <class T> void exarray<T>::grow (unsigned i)
{
  realloc (excalcsize (
    exmuladd (sizeof(T), i, sizeof(T))
  ));
}

//	  ,
//	   
//	  0.   
//	  , 
//	   0.
//	   exarray.cpp.

extern	class	{ void* e; unsigned len; } __EXNULL;

//	  .
//	   
//	   ,
//	     ,
//	    .
//	  
//	   
//	   .

template <class T> class expoint
{
  exarray<T>*	a;	//  .
  int	    	k;	//   .

public:

//	  .
//	   0.
//	    
//	,     ,
//	     
//	  abort().

  expoint ()      {a=(exarray<T>*)&__EXNULL; k=0;}

//	   
//	  .
//	    ,
//	   
//	   
//	  .
//	   ,
//	    ,
//	     
//	  abort().

  expoint (int i) {a=(exarray<T>*)&__EXNULL; k=i;}

//	   
//	  .
//	   
//	    
//	    
//	    .

  expoint (exarray<T>&m)	{ a = &m; k = 0; }
  expoint (exarray<T>&m, int i)	{ a = &m; k = i; }

//	     .

  T& operator [] (unsigned i) { return (*a)[k+i];}
  T& operator [] (int i)      { return (*a)[k+i];}
  T& operator *  ()	      { return (*a)[k];  }

//	     .

  T& item (int i) { return (a->item(k + i));	}
  T* base ()	  { return (a->base() + k);	}

//	   const T*
//	    
//	    const T*,  
//	  ,   -
//	    .
//	 ,   
//	   .

  operator const T* () { return (a->base());	}

//	 .

  expoint<T>  operator +  (unsigned i)
	{ return (expoint<T>(*a, k + i));	}

  expoint<T>  operator +  (int i)
	{ return (expoint<T>(*a, k + i));	}

  expoint<T>  operator -  (unsigned i)
	{ return (expoint<T>(*a, k - i));	}

  expoint<T>  operator -  (int i)
	{ return (expoint<T>(*a, k - i));	}

  expoint<T>& operator += (unsigned i)
	{ k += i;  return (*this);		}

  expoint<T>& operator += (int i)
	{ k += i;  return (*this);		}

  expoint<T>& operator -= (unsigned i)
	{ k -= i;  return (*this);		}

  expoint<T>& operator -= (int i)
	{ k -= i;  return (*this);		}

  expoint<T>& operator ++ ()
	{ k++;     return (*this);		}

  expoint<T>& operator -- ()
	{ k--;     return (*this);		}

  expoint<T>  operator ++ (int)
	{ expoint<T>t = *this; k++; return t;	}

  expoint<T>  operator -- (int)
	{ expoint<T>t = *this; k--; return t;	}
};

//	   string.h.

#include<string.h>
//	   Borland C++
#ifdef	__BORLANDC__
#pragma warn -ill
#pragma intrinsic -strcpy
#pragma intrinsic -strcat
#pragma warn .ill
#endif

inline	expoint<char>
strcpy	(expoint<char>__dest, const char *__src)
{
  __dest [strlen (__src)];	//  .
  strcpy (__dest.base(), __src);
  return (__dest);
}

inline	expoint<char>
strcat	(expoint<char>__dest, const char *__src)
{
  strcpy (__dest + strlen (__dest), __src);
  return (__dest);
}
