/* --------------------------------------------------------------
          ( 1.1a).

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2005, ..,   PAH.
    All Rights Reserved.

         "public domain",
    ..   ,  
         
          .

           .
        "AS IS"  - 
         .
-------------------------------------------------------------- */
#ifndef _CBIGNUM_H
#define _CBIGNUM_H

#ifndef __cplusplus
#error  Must use C++ for the type cBigNumber.
#endif

#include <iostream.h>

#ifndef EXARRAY_H
#include "Exarray.h"
#include "Exdebug.h"
#endif//EXARRAY_H

//================================================
//        cBigNumber.
//================================================
//             long.
//             long-,
//            
//       ,    -   ,
//            .
//           .
//             length().
//
//           
//        long-,     :
//      -     1,     
//             ;
//      -     .
//           .
//
//           
//        , ..  
//       long-,   0,    
//        .  
//       ,   ,  
//          .
//
//            exblock<long>
//              ,
//            long-,   
//       .      , 
//         -     
//      ,      .
//
//           :
//      checkexpand(n) -      
//                           .
//      checkindex(n)  -      
//                         .
//              .
//
//         checkexpand()  checkindex()   
//          ,    
//        .    
//           .
//
//         NCHECKPTR,   checkexpand() 
//           ,  
//         ,   checkindex()   .
//
//        NCHECKPTR  ,   checkexpand() 
//      checkindex()      .
//
//       :
//
//      exblock<long>           //   .
//      |
//      +- cBigNumber           //  .
//         |
//         +- cBigTemp          //    .
//            |
//            +- cBigInc        //  .
//            +- cBigDec        //  .
//            +- cBigPos        //  .
//            +- cBigNeg        // .
//            +- cBigCompl      //  .
//            +- cBigXor        //     2.
//            +- cBigAnd        //  .
//            +- cBigOr         //  .
//            +- cBigAdd        // .
//            +- cBigSub        // .
//            +- cBigMul        // .
//            +- cBigDiv        // .
//            +- cBigMod        // .
//            +- cBigShl        //  .
//            +- cBigShr        //  .
//            +- cBigPow        // .
//            +- cBigPowMod     //   .
//            +- cBigSqrt       //  .

//================================================
//        cBigNumber.
//================================================

class cBigNumber:       public exblock<long>
{
protected:                      //     
                                //     
  void  create (long b = 0)     // .   
  {                             //    checkexpand (1).
    e = (long *) exmalloc (EXCALCBLOCKSIZE_1);
    e [0] = 1; e [1] = b;
    len = max_size (EXCALCBLOCKSIZE_1);
    checkindex (1);
  }
                                        //   cBigTemp.
  cBigNumber (exblockstack<long> &stack) { stack.get(*this); }

public:

//      .                                   //  :
  cBigNumber ()                 { create (0);   }       // .
  cBigNumber (long b)           { create (b);   }       // .
  cBigNumber (const cBigNumber&);                       //  .
  cBigNumber (const char *psz, unsigned radix);         // .

//      .
  ~cBigNumber()                 { exfree (e);   }

//        .
  size_t      length () const   { return *(size_t*)e; } //  .
  const long* code   () const   { return e + 1;       } //  .
  const long& loword () const   { return e [1];       } //  .
  const long& hiword () const   { return e [length()];} //  .
  void        dump   () const;                          //   .
  void        erange () const;                          //  .
  int         isfit  () const;                          // ?
  int         bits   () const;                          //   .

//       .   -1 = , 0 = , 1 = .
  int         comp  (const cBigNumber&) const;          //  
  int         comp  (long)              const;          //  .
  int         comp0 ()                  const;          //   0.

//       .
//          ,   
//         .
  cBigNumber& fit   ();                                 // .
  cBigNumber& tab   ();                                 //  .
  cBigNumber& gc    ();                                 //  .
  cBigNumber& pack  ();                                 //  .
const cBigNumber& fit   () const { return ((cBigNumber*)this)->fit();   }
const cBigNumber& tab   () const { return ((cBigNumber*)this)->tab();   }
const cBigNumber& gc    () const { return ((cBigNumber*)this)->gc();    }
const cBigNumber& pack  () const { return ((cBigNumber*)this)->pack();  }

//        c  .
  cBigNumber& operator ++();                            //  .
  cBigNumber& operator --();                            //  .
  cBigNumber& neg   ()  { return setneg  (*this); }     //  .
//cBigNumber& compl ()  { return setcompl(*this); }     //  .
  cBigNumber& mul2  ();                                 //   2.
  cBigNumber& div2  ();                                 //   2.
  cBigNumber& pow2  ();                                 // .
  cBigNumber& sqrt  ();                                 //  .

//           .
//         .
  cBigNumber& set         (const cBigNumber&);          // .
  cBigNumber& set         (long);
  cBigNumber& setneg      (const cBigNumber&);          //  .
  cBigNumber& setneg      (long);
  cBigNumber& setcompl    (const cBigNumber&);          //  .
  cBigNumber& setcompl    (long);
  cBigNumber& setxor (const cBigNumber&, const cBigNumber&);    // 
  cBigNumber& setxor (const cBigNumber&, long);                 //  
  cBigNumber& setxor (long, const cBigNumber&);                 //  2.
  cBigNumber& setxor (long, long);
  cBigNumber& setand (const cBigNumber&, const cBigNumber&);    // 
  cBigNumber& setand (const cBigNumber&, long);                 // .
  cBigNumber& setand (long, const cBigNumber&);
  cBigNumber& setand (long, long);
  cBigNumber& setor  (const cBigNumber&, const cBigNumber&);    // 
  cBigNumber& setor  (const cBigNumber&, long);                 // .
  cBigNumber& setor  (long, const cBigNumber&);
  cBigNumber& setor  (long, long);
  cBigNumber& setadd (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setadd (const cBigNumber&, long);
  cBigNumber& setadd (long, const cBigNumber&);
  cBigNumber& setadd (long, long);
  cBigNumber& setsub (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setsub (const cBigNumber&, long);
  cBigNumber& setsub (long, const cBigNumber&);
  cBigNumber& setsub (long, long);
  cBigNumber& setmul (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setmul (const cBigNumber&, long);
  cBigNumber& setmul (long, const cBigNumber&);
  cBigNumber& setmul (long, long);
  cBigNumber& setdiv (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setdiv (const cBigNumber&, long);
  cBigNumber& setdiv (long, const cBigNumber&);
  cBigNumber& setdiv (long, long);
  cBigNumber& setmod (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setmod (const cBigNumber&, long);
  cBigNumber& setmod (long, const cBigNumber&);
  cBigNumber& setmod (long, long);
  cBigNumber& setshl (const cBigNumber&, const cBigNumber&);    // 
  cBigNumber& setshl (const cBigNumber&, long);                 // .
  cBigNumber& setshl (long, const cBigNumber&);
  cBigNumber& setshl (long, long);
  cBigNumber& setshr (const cBigNumber&, const cBigNumber&);    // 
  cBigNumber& setshr (const cBigNumber&, long);                 // .
  cBigNumber& setshr (long, const cBigNumber&);
  cBigNumber& setshr (long, long);
  cBigNumber& setpow (const cBigNumber&, const cBigNumber&);    // .
  cBigNumber& setpow (const cBigNumber&, long);
  cBigNumber& setpow (long, const cBigNumber&);
  cBigNumber& setpow (long, long);
  cBigNumber& setpowmod (const cBigNumber&, const cBigNumber&,  // 
                         const cBigNumber&);                    //  .
  cBigNumber& setpowmod (const cBigNumber&, long, const cBigNumber&);
  cBigNumber& setpowmod (long, const cBigNumber&, const cBigNumber&);
  cBigNumber& setpowmod (long, long, const cBigNumber&);
  cBigNumber& setpowmod (const cBigNumber&, const cBigNumber&, long);
  cBigNumber& setpowmod (const cBigNumber&, long, long);
  cBigNumber& setpowmod (long, const cBigNumber&, long);
  cBigNumber& setpowmod (long, long, long);
  cBigNumber& setsqrt   (const cBigNumber&);                    // . .
  cBigNumber& setsqrt   (long);

//      .
  cBigNumber& operator =  (const cBigNumber& b) { return set (b);       }
  cBigNumber& operator =  (long b)              { return set (b);       }

//        c  .
//          .
  cBigNumber& operator ^= (const cBigNumber&);  //   mod2
  cBigNumber& operator ^= (long);
  cBigNumber& operator &= (const cBigNumber&);  //  .
  cBigNumber& operator &= (long);
  cBigNumber& operator |= (const cBigNumber&);  //  .
  cBigNumber& operator |= (long);
  cBigNumber& operator += (const cBigNumber&);  // .
  cBigNumber& operator += (long);
  cBigNumber& operator -= (const cBigNumber&);  // .
  cBigNumber& operator -= (long);
  cBigNumber& operator *= (const cBigNumber&);  // .
  cBigNumber& operator *= (long);
  cBigNumber& operator /= (const cBigNumber&);  // .
  cBigNumber& operator /= (long);
  cBigNumber& operator %= (const cBigNumber&);  // .
  cBigNumber& operator %= (long);
  cBigNumber& operator<<= (const cBigNumber&);  //  .
  cBigNumber& operator<<= (long);
  cBigNumber& operator>>= (const cBigNumber&);  //  .
  cBigNumber& operator>>= (long);
  cBigNumber& pow         (const cBigNumber&);  // .
  cBigNumber& pow         (long);
  cBigNumber& powmod      (const cBigNumber&, const cBigNumber&);
  cBigNumber& powmod      (const cBigNumber&, long);
  cBigNumber& powmod      (long, const cBigNumber&);
  cBigNumber& powmod      (long, long);

//          .
//          ,
//          .
  cBigNumber& addmul      (const cBigNumber&, const cBigNumber&);
  cBigNumber& addmul      (const cBigNumber&, long);
  cBigNumber& addmul      (long, const cBigNumber&);
  cBigNumber& addmul      (long, long);

//      Combined    .
//          , 
//          .
  cBigNumber& setdivmod   (cBigNumber&, const cBigNumber&);
  cBigNumber& setdivmod   (cBigNumber&, long);

//      Combined     .
//          , 
//          .
  cBigNumber& setsqrtrm   (cBigNumber&);

//           .
//          .
//         .
//            .
  cBigNumber& addmultab   (const cBigNumber&, const cBigNumber&, size_t k = 0);
  cBigNumber& addmultab   (const cBigNumber&, long, size_t k = 0);

//         .
//          .
//       o  ,
//          
//            .
  cBigNumber& setdivtab (const cBigNumber&, const cBigNumber&); // .
  cBigNumber& setdivtab (long, const cBigNumber&);
  cBigNumber& setmodtab (const cBigNumber&, const cBigNumber&); // .
  cBigNumber& setmodtab (long, const cBigNumber&);

//           .
//             
//             .
//         .
//          .
  cBigNumber& setdivmodtab    (cBigNumber&, const cBigNumber&); //  
                                                                // .
//       .
  cBigNumber& set         (const char *psz,             // 
                           unsigned radix = 10);        //   .

  char*       toatmp      (unsigned radix = 10,         // 
                           ios& os = *(ios*)NULL        //  
                          )   const;                    //  .

//           .
  long        tolong      ()  const;
  int         toint       ()  const;
  short       toshort     ()  const;

//             C.
  operator  const void *  ()  const     { return (comp0()? e: 0);       }
  int         operator !  ()  const     { return (comp0() == 0);        }

//       .
static  void        maskdiv0   (int);   //    0.
static  int         testdiv0   ();      //     0?

//        .
static  cBigNumber& lastdivmod ();      //   .
static  cBigNumber& lastrootrm ();      //   .

//       .
  cBigNumber& set_        (const EXPTR(char) ps,        // 
                           unsigned radix,              //  char 
                           unsigned len);               //   .

private:
//        .
  cBigNumber& setpow_    ();
  cBigNumber& setpowmod_ (const cBigNumber&);
  cBigNumber& setpowmod_ (long);
};

//================================================
//        -.
//================================================
istream& operator >> (istream&, cBigNumber&);
ostream& operator << (ostream&, const cBigNumber&);

//================================================
//          .
//================================================

//      Strong Probable Primality test for base b
int     b_SPRP (const cBigNumber& n, const cBigNumber& b);

//================================================
//          (prime.cpp).
//================================================

//      Miller Strong Probable Primality test
int     SPRP    (const cBigNumber& n);

//      Factor Primality Test
int     HasFactor (const cBigNumber& n, size_t start = 0, size_t stop = 0);

//      Combined (Factor + Miller) Primality Test
int     IsPrime (const cBigNumber& n);

//================================================
//         
//        long   .
//================================================

class _cBigLong
{
  long e [2];           //  .

public:                 //   .

  _cBigLong         (long n = 0) { e [0] = 1; e [1] = n;        }

  _cBigLong& operator = (long n) { e [1] = n; return *this;     }

#ifdef  NCHECKPTR

//         
//           .

  long*       base()            { return (e);                   }

#else

//         
//           :
//            
//      ,  ::exalloc_status.range_handler.

  _cBigLong&  block()           { return (*this);               }
  exptr<long> begin()           { return exptr<long> (e, 2);    }
  operator    exptr<long>()     { return exptr<long> (e, 2);    }

#endif
};

#ifdef __cplusplus
extern "C" {
#endif

//================================================
//       .
//================================================

extern  size_t     cBigNumberMaskDiv0;      //    0.
extern  cBigNumber cBigNumberLastDivMod;    //   .
extern  cBigNumber cBigNumberLastRootRm;    //   .

//================================================
//        (Cbignumf.cpp).
//================================================

void    cBigNumberDump    (const EXPTR(long) p1, ostream& stream = cout);
void    cBigNumberERange  (const EXPTR(long) p1);
int     cBigNumberIsFit   (const EXPTR(long) p1);
int     cBigNumberBits    (const EXPTR(long) p1);
int     cLongBits         (long);
size_t  cBigNumberExpWords(const EXPTR(long) p1);
int     cBigNumberComp    (const EXPTR(long) p1, const EXPTR(long) p2);
void    cBigNumberCopy    (const EXPTR(long) p1, EXPTR(long) p);
void    cBigNumberCompl   (const EXPTR(long) p1, EXPTR(long) p);
void    cBigNumberCopyShl (const EXPTR(long) p1, size_t k1, EXPTR(long) p);
void    cBigNumberCopyShr (const EXPTR(long) p1, size_t k1, EXPTR(long) p);
void    cBigNumberCutOut  (const EXPTR(long) p1, size_t k1, size_t n,
                                 EXPTR(long) p);
size_t _cBigNumberNeg     (const EXPTR(long) p1, EXPTR(long) p);
size_t _cBigNumberMInc          (EXPTR(long) p1);
size_t _cBigNumberMDec          (EXPTR(long) p1);
size_t _cBigNumberMMul2         (EXPTR(long) p1);
size_t _cBigNumberMDiv2         (EXPTR(long) p1);
size_t _cBigNumberMul2    (const EXPTR(long) p1, EXPTR(long) p);
size_t _cBigNumberDiv2    (const EXPTR(long) p1, EXPTR(long) p);
size_t _cBigNumberFit           (EXPTR(long) p1);
size_t _cBigNumberFitTo         (EXPTR(long) p1, size_t n);
void    cBigNumberTab           (EXPTR(long) p1);
size_t _cBigNumberXor     (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberAnd     (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberOr      (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberAdd     (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberSub     (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberSubS    (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
size_t _cBigNumberMAdd          (EXPTR(long) p1, const EXPTR(long) p2);
size_t _cBigNumberMSub          (EXPTR(long) p1, const EXPTR(long) p2);
size_t  cBigNumberSkipLow0(const EXPTR(long) p1);
void    cBigNumberMAddM         (EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k2);
size_t _cBigNumberMSubD         (EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k2);
size_t _cBigNumberMMul2M        (EXPTR(long) p1);
size_t _cBigNumberMDiv2D        (EXPTR(long) p1);
void    cBigNumberMShrM         (EXPTR(long) p1);
void    cBigNumberMShlD         (EXPTR(long) p1);
void    cBigNumberMAddMulShl    (EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k, EXPTR(long) p);
void    cBigNumberMAddMulTab
                          (const EXPTR(long) p1, const EXPTR(long) p2,
                                 size_t k, EXPTR(long) p);
void    cBigNumberMAddMul (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
void    cBigNumberMul     (const EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
void    cBigNumberDiv0    (void);
void    cBigNumberMModDivTab    (EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
void    cBigNumberMModDiv       (EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
void    cBigNumberMModTab       (EXPTR(long) p1, const EXPTR(long) p2);
void    cBigNumberMMod          (EXPTR(long) p1, const EXPTR(long) p2);
void    cBigNumberPow           (EXPTR(long) p1, const EXPTR(long) p2,
                                 EXPTR(long) p);
void    cBigNumberPowMod        (EXPTR(long) p1, const EXPTR(long) p2,
                                                 const EXPTR(long) mod,
                                 EXPTR(long) p);
void    cBigNumberMRmSqrt       (EXPTR(long) p1, EXPTR(long) p);
#ifdef __cplusplus
}
#endif

//================================================
//       inline - .
//================================================

inline  size_t  cBigNumberNeg     (const EXPTR(long) p1, EXPTR(long) p)
{
  return (size_t)(*(p)=_cBigNumberNeg (p1, p));
}

inline  size_t  cBigNumberMInc          (EXPTR(long) p1)
{
  return (size_t)(*(p1)=_cBigNumberMInc (p1));
}

inline  size_t  cBigNumberMDec          (EXPTR(long) p1)
{
  return (size_t)(*(p1)=_cBigNumberMDec (p1));
}

inline  size_t  cBigNumberMMul2         (EXPTR(long) p1)
{
  return (size_t)(*(p1)=_cBigNumberMMul2 (p1));
}

inline  size_t  cBigNumberMDiv2         (EXPTR(long) p1)
{
  return (size_t)(*(p1)=_cBigNumberMDiv2 (p1));
}

inline  size_t  cBigNumberMul2   (const EXPTR(long) p1, EXPTR(long) p)
{
  return (size_t)(*(p)=_cBigNumberMul2 (p1, p));
}

inline  size_t  cBigNumberDiv2   (const EXPTR(long) p1, EXPTR(long) p)
{
  return (size_t)(*(p)=_cBigNumberDiv2 (p1, p));
}

inline  size_t  cBigNumberFit          (EXPTR(long) p1)
{
  return (size_t)(*(p1)=_cBigNumberFit (p1));
}

inline  size_t  cBigNumberFitTo        (EXPTR(long) p1, size_t n)
{
  return (size_t)(*(p1)=_cBigNumberFitTo (p1, n));
}

inline  size_t  cBigNumberXor    (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=_cBigNumberXor (p1, p2, p));
}

inline  size_t  cBigNumberAnd    (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=_cBigNumberAnd (p1, p2, p));
}

inline  size_t  cBigNumberOr     (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=_cBigNumberOr  (p1, p2, p));
}

inline  size_t  cBigNumberAdd    (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=_cBigNumberAdd (p1, p2, p));
}

inline  size_t  cBigNumberSub    (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=_cBigNumberSub (p1, p2, p));
}

inline  size_t  cBigNumberSubS   (const EXPTR(long) p1, const EXPTR(long) p2,
                                        EXPTR(long) p)
{
  return (size_t)(*(p)=_cBigNumberSubS (p1, p2, p));
}

inline  size_t  cBigNumberMAdd         (EXPTR(long) p1, const EXPTR(long) p2)
{
  return (size_t)(*(p1)=_cBigNumberMAdd (p1, p2));
}

inline  size_t  cBigNumberMSub         (EXPTR(long) p1, const EXPTR(long) p2)
{
  return (size_t)(*(p1)=_cBigNumberMSub (p1, p2));
}

inline  size_t  cBigNumberMSubD        (EXPTR(long) p1, const EXPTR(long) p2,
                                        size_t k2)
{
  return (size_t)(*(p1)=_cBigNumberMSubD (p1, p2, k2));
}

inline  size_t  cBigNumberMMul2M        (EXPTR(long) p1)
{
  return (size_t)(*(p1)=_cBigNumberMMul2M (p1));
}

inline  size_t  cBigNumberMDiv2D        (EXPTR(long) p1)
{
  return (size_t)(*(p1)=_cBigNumberMDiv2D (p1));
}

//================================================
//       .
//================================================

inline cBigNumber::cBigNumber (const cBigNumber& b)
{
  e = NULL; len = 0;                    //  ,
  checkexpand (b.length());             //  .
  cBigNumberCopy (EXPTRTYPE(b), EXPTRTYPE(*this));      // .
}

inline cBigNumber::cBigNumber (const char *psz, unsigned radix)
{
  create();                             //  .
  set (psz, radix);                     //  .
}

//================================================
//        .
//================================================

inline void cBigNumber::dump()      const
{
  cBigNumberDump (EXPTRTYPE(*this));
}

inline void cBigNumber::erange()    const
{
  cBigNumberERange (EXPTRTYPE(*this));
}

inline int  cBigNumber::isfit()     const
{
  return cBigNumberIsFit (EXPTRTYPE(*this));
}

inline int  cBigNumber::bits()      const
{
  return cBigNumberBits (EXPTRTYPE(*this));
}

//================================================
//        .
//================================================

inline int      cBigNumber::comp (const cBigNumber& b)  const
{
  return cBigNumberComp (EXPTRTYPE(*this), EXPTRTYPE(b));
}

inline int      cBigNumber::comp (long b)               const
{
  return cBigNumberComp (EXPTRTYPE(*this), EXPTRTYPE(_cBigLong(b)));
}

inline int      cBigNumber::comp0 ()                    const
{
  return cBigNumberComp (EXPTRTYPE(*this), EXPTRTYPE(_cBigLong(0)));
}

//================================================
//        .
//================================================

inline cBigNumber& cBigNumber::set         (const cBigNumber& b)
{
  checkexpand (b.length()); cBigNumberCopy (EXPTRTYPE(b), EXPTRTYPE(*this));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::set         (long b)
{
  if (e == NULL) create();
  e[0] = 1; e[1] = b;
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::setneg      (const cBigNumber& b)
{
  checkexpand (b.length() + 1); cBigNumberNeg (EXPTRTYPE(b), EXPTRTYPE(*this));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::setneg      (long b)
{
  checkexpand (2); e[0] = 1 + (b == LONG_MIN); e[1] = -b; e[2] = 0;
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::setcompl    (const cBigNumber& b)
{
  checkexpand (b.length()); cBigNumberCompl (EXPTRTYPE(b), EXPTRTYPE(*this));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::setcompl    (long b)
{
  if (e == NULL) create();
  e[0] = 1; e[1] = ~b;
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::operator ^= (const cBigNumber& b)
{
  return setxor (*this, b);
}

inline cBigNumber& cBigNumber::operator ^= (long b)
{
  return setxor (*this, b);
}

inline cBigNumber& cBigNumber::operator &= (const cBigNumber& b)
{
  return setand (*this, b);
}

inline cBigNumber& cBigNumber::operator &= (long b)
{
  return setand (*this, b);
}

inline cBigNumber& cBigNumber::operator |= (const cBigNumber& b)
{
  return setor (*this, b);
}

inline cBigNumber& cBigNumber::operator |= (long b)
{
  return setor (*this, b);
}

inline cBigNumber& cBigNumber::operator += (const cBigNumber& b)
{
  return setadd (*this, b);
}

inline cBigNumber& cBigNumber::operator += (long b)
{
  return setadd (*this, b);
}

inline cBigNumber& cBigNumber::operator -= (const cBigNumber& b)
{
  return setsub (*this, b);
}

inline cBigNumber& cBigNumber::operator -= (long b)
{
  return setsub (*this, b);
}

inline cBigNumber& cBigNumber::operator *= (const cBigNumber& b)
{
  return setmul (*this, b);
}

inline cBigNumber& cBigNumber::operator *= (long b)
{
  return setmul (*this, b);
}

inline cBigNumber& cBigNumber::operator /= (const cBigNumber& b)
{
  swap (cBigNumberLastDivMod);
  checkexpand (cBigNumberLastDivMod.length() + 2);
  cBigNumberMModDiv (EXPTRTYPE(cBigNumberLastDivMod), EXPTRTYPE(b),
                     EXPTRTYPE(*this));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::operator /= (long b)
{
  swap (cBigNumberLastDivMod);
  checkexpand (cBigNumberLastDivMod.length() + 2);
  cBigNumberMModDiv (EXPTRTYPE(cBigNumberLastDivMod), EXPTRTYPE(_cBigLong(b)),
                     EXPTRTYPE(*this));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::operator %= (const cBigNumber& b)
{
  cBigNumberMMod (EXPTRTYPE(*this), EXPTRTYPE(b));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::operator %= (long b)
{
  cBigNumberMMod (EXPTRTYPE(*this), EXPTRTYPE(_cBigLong(b)));
  checkindex (length());
  return *this;
}

inline cBigNumber& cBigNumber::pow (const cBigNumber& b)
{
  return setpow (*this, b);
}

inline cBigNumber& cBigNumber::pow (long b)
{
  return setpow (*this, b);
}

inline cBigNumber& cBigNumber::powmod (const cBigNumber& b,
                                       const cBigNumber& mod)
{
  return setpowmod (*this, b, mod);
}

inline cBigNumber& cBigNumber::powmod (const cBigNumber& b, long mod)
{
  return setpowmod (*this, b, mod);
}

inline cBigNumber& cBigNumber::powmod (long b, const cBigNumber& mod)
{
  return setpowmod (*this, b, mod);
}

inline cBigNumber& cBigNumber::powmod (long b, long mod)
{
  return setpowmod (*this, b, mod);
}

//================================================
//         .
//================================================

inline  int  operator == (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) == 0);
}

inline  int  operator == (const cBigNumber& a, long b)
{
  return (a.comp(b) == 0);
}

inline  int  operator == (long b, const cBigNumber& a)
{
  return (a.comp(b) == 0);
}

inline  int  operator != (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) != 0);
}

inline  int  operator != (const cBigNumber& a, long b)
{
  return (a.comp(b) != 0);
}

inline  int  operator != (long b, const cBigNumber& a)
{
  return (a.comp(b) != 0);
}

inline  int  operator >= (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) >= 0);
}

inline  int  operator >= (const cBigNumber& a, long b)
{
  return (a.comp(b) >= 0);
}

inline  int  operator >= (long b, const cBigNumber& a)
{
  return (a.comp(b) <= 0);
}

inline  int  operator <= (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) <= 0);
}

inline  int  operator <= (const cBigNumber& a, long b)
{
  return (a.comp(b) <= 0);
}

inline  int  operator <= (long b, const cBigNumber& a)
{
  return (a.comp(b) >= 0);
}

inline  int  operator >  (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) > 0);
}

inline  int  operator >  (const cBigNumber& a, long b)
{
  return (a.comp(b) > 0);
}

inline  int  operator >  (long b, const cBigNumber& a)
{
  return (a.comp(b) < 0);
}

inline  int  operator <  (const cBigNumber& a, const cBigNumber& b)
{
  return (a.comp(b) < 0);
}

inline  int  operator <  (const cBigNumber& a, long b)
{
  return (a.comp(b) < 0);
}

inline  int  operator <  (long b, const cBigNumber& a)
{
  return (a.comp(b) > 0);
}

//================================================
//        .
//================================================

inline  long    cBigNumber::tolong()  const
{
  if (size() == 0)      return (0);
  if (length() > 1)     erange();
  return (hiword());
}

inline  int     cBigNumber::toint()   const
{
  long n = tolong();
  if ((int) n != n)     erange();
  return ((int)n);
}

inline  short   cBigNumber::toshort() const
{
  long n = tolong();
  if ((short) n != n)   erange();
  return ((short)n);
}

//================================================
//        .
//================================================

inline void     cBigNumber::maskdiv0 (int mask)
{
  cBigNumberMaskDiv0 = (mask << 1);
}

inline int      cBigNumber::testdiv0()
{
  return (cBigNumberMaskDiv0 == 1);
}

inline cBigNumber& cBigNumber::lastdivmod()
{
  return (cBigNumberLastDivMod);
}

inline cBigNumber& cBigNumber::lastrootrm()
{
  return (cBigNumberLastRootRm);
}

//================================================
//      -   ,
//         .
//================================================

class cBigTemp: public cBigNumber               //    .
{
//       cBigTemp   
//         .
//
//           cBigTemp.
//         , 
//         :
//          cBigTemp   
//          ,   
//       cBigTemp     .
//           
//         ,   .
//
//        ,  
//          cBigTemp.

protected:

  static exblockstack<long> stack;      //   .

  cBigTemp (): cBigNumber (stack)   {}  // .
  ~cBigTemp()  { stack.put (*this);  }  // .
/*
  cBigTemp ()  {}                       // .
  ~cBigTemp()  {}                       // .
*/
//          cBigNumber.
//         ,    
//          (-x) = 10;

private:

  cBigNumber& neg   ();                         //  .
//cBigNumber& compl ();                         //  .
  cBigNumber& operator ++ ();                   //  .
  cBigNumber& operator -- ();                   //  .
  cBigNumber& mul2  ();                         //   2.
  cBigNumber& div2  ();                         //   2.
  cBigNumber& pow2  ();                         // .
  cBigNumber& fit   ();                         // .
  cBigNumber& tab   ();                         //   .
  cBigNumber& gc    ();                         //  .
  cBigNumber& pack  ();                         //  .
  cBigNumber& operator =  (const cBigNumber&);  //   mod2
  cBigNumber& operator =  (long);
  cBigNumber& operator ^= (const cBigNumber&);  //   mod2
  cBigNumber& operator ^= (long);
  cBigNumber& operator &= (const cBigNumber&);  //  .
  cBigNumber& operator &= (long);
  cBigNumber& operator |= (const cBigNumber&);  //  .
  cBigNumber& operator |= (long);
  cBigNumber& operator += (const cBigNumber&);  // .
  cBigNumber& operator += (long);
  cBigNumber& operator -= (const cBigNumber&);  // .
  cBigNumber& operator -= (long);
  cBigNumber& operator *= (const cBigNumber&);  // .
  cBigNumber& operator *= (long);
  cBigNumber& operator /= (const cBigNumber&);  // .
  cBigNumber& operator /= (long);
  cBigNumber& operator %= (const cBigNumber&);  // .
  cBigNumber& operator %= (long);
  cBigNumber& operator<<= (const cBigNumber&);  //  .
  cBigNumber& operator<<= (long);
  cBigNumber& operator>>= (const cBigNumber&);  //  .
  cBigNumber& operator>>= (long);
  cBigNumber& pow         (const cBigNumber&);  // .
  cBigNumber& pow         (long);
  cBigNumber& addmul      (const cBigNumber&, const cBigNumber&);
  cBigNumber& addmul      (const cBigNumber&, long);
  cBigNumber& addmul      (long, const cBigNumber&);
  cBigNumber& addmul      (long, long);
};

struct cBigInc: public cBigTemp                 //  .
{
  cBigInc   (cBigNumber& a)                             { set (a); ++a; }
};

struct cBigDec: public cBigTemp                 //  .
{
  cBigDec   (cBigNumber& a)                             { set (a); --a; }
};

struct cBigPos: public cBigTemp                 //  .
{
  cBigPos   (const cBigNumber& a)                       { set (a);      }
  cBigPos   (long a)                                    { set (a);      }
};

struct cBigNeg: public cBigTemp                 //  .
{
  cBigNeg   (const cBigNumber& a)                       { setneg (a);   }
  cBigNeg   (long a)                                    { setneg (a);   }
};

struct cBigCompl: public cBigTemp               //  .
{
  cBigCompl (const cBigNumber& a)                       { setcompl (a); }
  cBigCompl (long a)                                    { setcompl (a); }
};

struct cBigXor: public cBigTemp                 //     2.
{
  cBigXor (const cBigNumber& a, const cBigNumber& b)    { setxor (a, b); }
  cBigXor (const cBigNumber& a, long b)                 { setxor (a, b); }
  cBigXor (long a, const cBigNumber& b)                 { setxor (a, b); }
  cBigXor (long a, long b)                              { setxor (a, b); }
};

struct cBigAnd: public cBigTemp                 //  .
{
  cBigAnd (const cBigNumber& a, const cBigNumber& b)    { setand (a, b); }
  cBigAnd (const cBigNumber& a, long b)                 { setand (a, b); }
  cBigAnd (long a, const cBigNumber& b)                 { setand (a, b); }
  cBigAnd (long a, long b)                              { setand (a, b); }
};

struct cBigOr : public cBigTemp                 //  .
{
  cBigOr  (const cBigNumber& a, const cBigNumber& b)    { setor  (a, b); }
  cBigOr  (const cBigNumber& a, long b)                 { setor  (a, b); }
  cBigOr  (long a, const cBigNumber& b)                 { setor  (a, b); }
  cBigOr  (long a, long b)                              { setor  (a, b); }
};

struct cBigAdd: public cBigTemp                         // .
{
  cBigAdd (const cBigNumber& a, const cBigNumber& b)    { setadd (a, b); }
  cBigAdd (const cBigNumber& a, long b)                 { setadd (a, b); }
  cBigAdd (long a, const cBigNumber& b)                 { setadd (a, b); }
  cBigAdd (long a, long b)                              { setadd (a, b); }
};

struct cBigSub: public cBigTemp                         // .
{
  cBigSub (const cBigNumber& a, const cBigNumber& b)    { setsub (a, b); }
  cBigSub (const cBigNumber& a, long b)                 { setsub (a, b); }
  cBigSub (long a, const cBigNumber& b)                 { setsub (a, b); }
  cBigSub (long a, long b)                              { setsub (a, b); }
};

struct cBigMul: public cBigTemp                         // .
{
  cBigMul (const cBigNumber& a, const cBigNumber& b)    { setmul (a, b); }
  cBigMul (const cBigNumber& a, long b)                 { setmul (a, b); }
  cBigMul (long a, const cBigNumber& b)                 { setmul (a, b); }
  cBigMul (long a, long b)                              { setmul (a, b); }
};

struct cBigDiv: public cBigTemp                         // .
{
  cBigDiv (const cBigNumber& a, const cBigNumber& b)    { setdiv (a, b); }
  cBigDiv (const cBigNumber& a, long b)                 { setdiv (a, b); }
  cBigDiv (long a, const cBigNumber& b)                 { setdiv (a, b); }
  cBigDiv (long a, long b)                              { setdiv (a, b); }
};

struct cBigMod: public cBigTemp                         // .
{
  cBigMod (const cBigNumber& a, const cBigNumber& b)    { setmod (a, b); }
  cBigMod (const cBigNumber& a, long b)                 { setmod (a, b); }
  cBigMod (long a, const cBigNumber& b)                 { setmod (a, b); }
  cBigMod (long a, long b)                              { setmod (a, b); }
};

struct cBigShl: public cBigTemp                         //  .
{
  cBigShl (const cBigNumber& a, const cBigNumber& b)    { setshl (a, b); }
  cBigShl (const cBigNumber& a, long b)                 { setshl (a, b); }
  cBigShl (long a, const cBigNumber& b)                 { setshl (a, b); }
  cBigShl (long a, long b)                              { setshl (a, b); }
};

struct cBigShr: public cBigTemp                         //  .
{
  cBigShr (const cBigNumber& a, const cBigNumber& b)    { setshr (a, b); }
  cBigShr (const cBigNumber& a, long b)                 { setshr (a, b); }
  cBigShr (long a, const cBigNumber& b)                 { setshr (a, b); }
  cBigShr (long a, long b)                              { setshr (a, b); }
};

struct cBigPow: public cBigTemp                         // .
{
  cBigPow (const cBigNumber& a, const cBigNumber& b)    { setpow (a, b); }
  cBigPow (const cBigNumber& a, long b)                 { setpow (a, b); }
  cBigPow (long a, const cBigNumber& b)                 { setpow (a, b); }
  cBigPow (long a, long b)                              { setpow (a, b); }
};

struct cBigPowMod: public cBigTemp                      //   .
{
  cBigPowMod (const cBigNumber& a, const cBigNumber& b, cBigNumber& mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (const cBigNumber& a, long b, cBigNumber& mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (long a, const cBigNumber& b, cBigNumber& mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (long a, long b, cBigNumber& mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (const cBigNumber& a, const cBigNumber& b, long mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (const cBigNumber& a, long b, long mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (long a, const cBigNumber& b, long mod)
                                                { setpowmod (a, b, mod); }
  cBigPowMod (long a, long b, long mod)
                                                { setpowmod (a, b, mod); }
};

struct cBigSqrt: public cBigTemp                        //  .
{
  cBigSqrt (const cBigNumber& a)                        { setsqrt (a);   }
  cBigSqrt (long a)                                     { setsqrt (a);   }
};

//================================================
//         ,
//         .
//================================================

inline cBigInc  operator ++ (cBigNumber &a, int)
{
  return cBigInc (a);
}

inline cBigDec  operator -- (cBigNumber &a, int)
{
  return cBigDec (a);
}

inline cBigPos   operator + (const cBigNumber &a)
{
  return cBigPos (a);
}

inline cBigNeg   operator - (const cBigNumber &a)
{
  return cBigNeg (a);
}

inline cBigCompl operator ~ (const cBigNumber &a)
{
  return cBigCompl (a);
}

//================================================
//         ,
//         .
//================================================

inline cBigXor operator ^ (const cBigNumber& a, const cBigNumber& b)
{
  return cBigXor (a, b);
}

inline cBigXor operator ^ (const cBigNumber& a, long b)
{
  return cBigXor (a, b);
}

inline cBigXor operator ^ (long b, const cBigNumber& a)
{
  return cBigXor (a, b);
}

inline cBigAnd operator & (const cBigNumber& a, const cBigNumber& b)
{
  return cBigAnd (a, b);
}

inline cBigAnd operator & (const cBigNumber& a, long b)
{
  return cBigAnd (a, b);
}

inline cBigAnd operator & (long b, const cBigNumber& a)
{
  return cBigAnd (a, b);
}

inline cBigOr  operator | (const cBigNumber& a, const cBigNumber& b)
{
  return cBigOr  (a, b);
}

inline cBigOr  operator | (const cBigNumber& a, long b)
{
  return cBigOr  (a, b);
}

inline cBigOr  operator | (long b, const cBigNumber& a)
{
  return cBigOr  (a, b);
}

inline cBigAdd operator + (const cBigNumber& a, const cBigNumber& b)
{
  return cBigAdd (a, b);
}

inline cBigAdd operator + (const cBigNumber& a, long b)
{
  return cBigAdd (a, b);
}

inline cBigAdd operator + (long b, const cBigNumber& a)
{
  return cBigAdd (a, b);
}

inline cBigSub operator - (const cBigNumber& a, const cBigNumber& b)
{
  return cBigSub (a, b);
}

inline cBigSub operator - (const cBigNumber& a, long b)
{
  return cBigSub (a, b);
}

inline cBigSub operator - (long a, const cBigNumber& b)
{
  return cBigSub (a, b);
}

inline cBigMul operator * (const cBigNumber& a, const cBigNumber& b)
{
  return cBigMul (a, b);
}

inline cBigMul operator * (const cBigNumber& a, long b)
{
  return cBigMul (a, b);
}

inline cBigMul operator * (long b, const cBigNumber& a)
{
  return cBigMul (a, b);
}

inline cBigDiv operator / (const cBigNumber& a, const cBigNumber& b)
{
  return cBigDiv (a, b);
}

inline cBigDiv operator / (const cBigNumber& a, long b)
{
  return cBigDiv (a, b);
}

inline cBigDiv operator / (long a, const cBigNumber& b)
{
  return cBigDiv (a, b);
}

inline cBigMod operator % (const cBigNumber& a, const cBigNumber& b)
{
  return cBigMod (a, b);
}

inline cBigMod operator % (const cBigNumber& a, long b)
{
  return cBigMod (a, b);
}

inline cBigMod operator % (long a, const cBigNumber& b)
{
  return cBigMod (a, b);
}

inline cBigShl operator << (const cBigNumber& a, const cBigNumber& b)
{
  return cBigShl (a, b);
}

inline cBigShl operator << (const cBigNumber& a, long b)
{
  return cBigShl (a, b);
}

inline cBigShl operator << (long a, const cBigNumber& b)
{
  return cBigShl (a, b);
}

inline cBigShr operator >> (const cBigNumber& a, const cBigNumber& b)
{
  return cBigShr (a, b);
}

inline cBigShr operator >> (const cBigNumber& a, long b)
{
  return cBigShr (a, b);
}

inline cBigShr operator >> (long a, const cBigNumber& b)
{
  return cBigShr (a, b);
}

#endif//_CBIGNUM_H
