/* --------------------------------------------------------------
          ( 1.1a).
       - .

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2005, ..,   PAH.
    All Rights Reserved.

         "public domain",
    ..   ,  
         
          .

           .
        "AS IS"  - 
         .
-------------------------------------------------------------- */
#ifdef  _MSC_VER
#pragma warning(disable:4995)
#endif/*_MSC_VER*/
#include <ctype.h>
#include <stdlib.h>
#include <iomanip.h>
#include <limits.h>
#include "Cbignum.h"
#include <assert.h>
#define BITS            (CHAR_BIT * sizeof (long))

//================================================
//        .
//================================================
//      SHIFT_TAB_MIN       ,
//                           
//                        
//
//      SHIFT_TAB_OPT      
//                          ;
//                          8n - 3.
//
//      SHIFT_TAB_HIGH     
//                          .
//
//      SHIFT_TAB_MAX     ,  
//                          .

#define SHIFT_TAB_MIN   (3)
#define SHIFT_TAB_OPT   ((sizeof(size_t))==2? 15-3: 480-3)
#define SHIFT_TAB_HIGH  (SHIFT_TAB_OPT + SHIFT_TAB_OPT / 2)
#define SHIFT_TAB_MAX   (EXSIZE_T_MAX / (1024 * sizeof (long)))

//================================================
//       .
//================================================

inline size_t size_max (size_t n1, size_t n2)
{
  return ((n1 > n2)? n1 : n2);
}
inline size_t size_min (size_t n1, size_t n2)
{
  return ((n1 < n2)? n1 : n2);
}

#ifdef  __cplusplus
extern "C" {
#endif//__cplusplus

//================================================
//          cBigNumber.
//================================================
//             long.
//             long-,
//            
//       ,    -   ,
//            .
//           .
//
//            C.
//           EXPTR(long):
//       long *     exptr<long>  
//             .
//           const.
//            
//           ;  
//             size_t.
//            ;
//        inline-,  
//          .
//
//         
//        :
//      NDEBUG    -    
//                       
//                     .
//                      
//      NCHECKPTR -    
//                    .
//
//         cBigNumber... 
//       ,      
//         .
//         , 
//          
//       Pentium.

//================================================
//       .
//================================================

//           
//          .   
//           ,
//            .
//          .

void    cBigNumberDump (                        //  .
                const   EXPTR(long) p1,         //  .
                ostream& stream                 // .
        )
{
  char fill  = stream.fill  ('0');              // .
  long flags = stream.flags (ios::hex);         //  .

  size_t n1 = (size_t)(*p1);                    //  .
  for (; n1; n1--) stream <<" "<< setw(8) << (unsigned long) p1 [n1];
  stream << endl;

  stream.fill  (fill);                          //  .
  stream.flags (flags);                         //  .
}

void    cBigNumberERange (                      //   .
                const   EXPTR(long) p1          //  .
)
{
  cerr <<"cBigNumber value is out of range:";
  cBigNumberDump (p1, cerr);                    // .
  abort();                                      // .
}

//           
//        long-,     :
//      -     1,     
//             ;
//      -     .
//           .

int     cBigNumberIsFit (                       //  .
                const   EXPTR(long) p1          //  .
        )                                       //   ,
{                                               //   1  0.
  size_t n1 = (size_t)(*p1);                    //  .
  if (n1)
  {
    if (n1 > 1) return ((p1 [n1] != (p1 [n1-1] >> (BITS-1))));
  }
  return (n1);                                  //   0.
}

//          ,   
//              .
//      ,  0  -1   , 1  -2  1  ,
//       127  -128  7  .
//         n     2   n.
//         :     .

int     cBigNumberBits (                        //   .
                const   EXPTR(long) p1          //  .
        )       //   n   pow(2,n) >= abs(p1).
                //     INT_MAX,   INT_MAX.
{
  size_t n1 = (int)(*p1);                       //  .
  if (n1)
  {
    long sign = p1 [n1];                        // .
    do
    {
      unsigned long num = p1 [n1];              //  .
      if (sign < 0) num = ~num;                 //  .
      if (num)                                  //   ?
      {
        if (n1 <= (INT_MAX / BITS))
        {
          n1 *= BITS;                           //    .
          if (num < (1L<<(BITS/2)))             //  1-  .
          {
            n1 -= BITS; do ++n1; while ((num >>= 1) > 0);
          }
          else if ((long)num > 0)
          {
            do --n1; while ((long)(num <<= 1) > 0);
          }
        }
        else n1 = INT_MAX;                      // .
        break;                                  //  .
      }
    }
    while (--n1 != 0);
  }
  return (n1);
}

//           .

int     cLongBits (long num)                    //   .
{
  int n1 = BITS;
  if (num < 0) num = ~num;                      //  .
  if (num >= (1L<<(BITS/2)))                    //    .
  {
    do --n1; while ((num <<= 1) > 0);
  }
  else
  {
    n1 -= BITS; if (num) do ++n1; while ((num >>= 1) > 0);
  }
  return (n1);
}

//            
//           .

size_t  cBigNumberExpWords (                    //   0-.
                const   EXPTR(long) p1          //    .
)
{
  size_t n1 = (size_t)(*p1);                    //   p1.
  size_t n = 0;                                 //  0- p1.
  for (; n != n1; n++)
  {
    if (p1 [n + 1] == 0) break;                 //   .
  }
  return (n);
}

//================================================
//       .
//================================================

//          
//          .
//           
//             .
//         - , 
//        - .

//           
//          .

int     cBigNumberComp  (                       //  p1, p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2          // .
        )                                       //  -1  p1 <  p2
                                                //   0  p1 == p2
                                                //   1  p1  > p2
{                                               // p1, p2  .
  size_t n1 = (size_t)(*p1);                    //    p1.
  size_t n2 = (size_t)(*p2);                    //    p2.
  register long lp1 = 0;                        //   p1.
  register long lp2 = 0;                        //   p2.

//        .

  if (n1) lp1 = p1 [n1--];                      //   p1.
  if (n2) lp2 = p2 [n2--];                      //   p2.

  if (n1 == n2)                                 //  p1, p2 .
  {
    if (lp1 != lp2) goto NotSameSignWord;       //    .
  }
  else if (n1 > n2)                             //   p1 , 
  {                                             //   
    lp2 >>= (BITS-1); ++n2;                     //   p2.
    if (lp1 != lp2) goto NotSameSignWord;       //    .
    if (n1 > n2)                                //   .
    {
      do                                        //  .
      {
        lp1 = p1 [n1]; --n1;                    //  .
        if (lp1 != lp2) goto NotSame;           //   .
      }
      while (n1 > n2);                          //   .
    }
  }
  else // (n1 < n2)                             //   p2 , 
  {                                             //   
    lp1 >>= (BITS-1); ++n1;                     //   p1.
    if (lp1 != lp2) goto NotSameSignWord;       //    .
    if (n1 < n2)                                //   .
    {
      do                                        //  .
      {
        lp2 = p2 [n2]; --n2;                    //  .
        if (lp1 != lp2) goto NotSame;           //   .
      }
      while (n1 < n2);                          //   .
    }
  }

//         .

  if (n1)
  {
    do                                          //  .
    {
      lp1 = p1 [n1]; lp2 = p2 [n1]; --n1;       //  .
      if (lp1 != lp2) goto NotSame;             //   .
    }
    while (n1);                                 //   .
  }

  return (0);                                   //  .
NotSame:                                        //   .
  return (((unsigned long)lp1 >= (unsigned long)lp2) * 2 - 1);
NotSameSignWord:                                //    .
  return ((lp1 >= lp2) * 2 - 1);
}

//================================================
//        .
//================================================

//        .
//      , :
//      -  .
//      -        .
//       c       .

int     cBigNumberCompHigh (                    //    .
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2          // .
        )                                       //  -1  p1 <  p2
                                                //   0  p1 == p2
                                                //   1  p1  > p2
{                                               // p1, p2  .
  assert (cBigNumberIsFit(p1));                 //  .
  assert (cBigNumberIsFit(p2));                 //  .
  size_t n1 = (size_t)(*p1);                    //    p1.
  size_t n2 = (size_t)(*p2);                    //    p2.
  assert (n1 >= n2);                            //  .
  assert (n2 > 0);                              //  .

//        .

  register long lp1 = p1 [n1--];                //   p1.
  register long lp2 = p2 [n2--];                //   p2.
  if (lp1 != lp2) return ((lp1 >= lp2) * 2 - 1);//   .

//         .

  if (n2)
  do                                            //  .
  {
    lp1 = p1 [n1--]; lp2 = p2 [n2--];           //  .
    if (lp1 != lp2)                             //   .
      return (((unsigned long)lp1 >= (unsigned long)lp2) * 2 - 1);
  }
  while (n2);                                   //   .

//         .

  if (n1)
  do
  {
    if (p1 [n1--] != 0) return 1;               // .
  }
  while (n1);

  return (0);                                   //  .
}

//       c 0.
//           .
//           .
//             ,
//        2 (   
//         ,     > 1).

inline  long    cBigNumberNot0  (               //   0:
                const EXPTR(long) p1            //  0  p1 == 0
                )                               //    0.
{
  assert (cBigNumberIsFit(p1));                 //  .
  size_t n1 = (size_t)(*p1);
  return (p1 [n1] | (long)(n1 >> 1));
}


//================================================
//          .
//================================================

void    cBigNumberCopy (                        //  p = p1.
                const   EXPTR(long) p1,         //  .
                        EXPTR(long) p           //   *p1 + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p++ = *p1++);           //  .
  if (n1)
  do                                            //   .
    { *p++ = *p1++; }                           //  .
  while (--n1 != 0);                            //   .
}

void    cBigNumberCompl (                       //  p = ~p1.
                const   EXPTR(long) p1,         //  .
                        EXPTR(long) p           //   *p1 + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p++ = *p1++);           //  .
  if (n1)
  do                                            //   .
    { *p++ = ~*p1++; }                          //  .
  while (--n1 != 0);                            //   .
}

//================================================
//           .
//================================================

//           ,
//            0.
//          2   (BITS * k1).
//
//             
//       ,   
//        ,   .

void    cBigNumberCopyShl (                     //  p = p1<<(BITS*k1).
                const   EXPTR(long) p1,         //  .
                        size_t      k1,         //  .
                        EXPTR(long) p           //   *p1 + k1 + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  if (n1 <= 1 && p1 [n1] == 0) k1 = 0;          //  .
  p1 += n1; *p = n1 + k1; p += (n1 + k1);
  if (n1)
  do                                            //   .
    { *p-- = *p1--; }                           //  .
  while (--n1 != 0);                            //   .
  if (k1)
  do                                            //   .
    { *p-- = 0; }                               //  .
  while (--k1 != 0);                            //   .
}

//            .
//          2   (BITS * k1).
//
//             
//       ,   
//        ,   .

void    cBigNumberCopyShr (                     //  p = p1>>(BITS*k1).
                const   EXPTR(long) p1,         //  .
                        size_t      k1,         //  .
                        EXPTR(long) p           //   *p1 - k1 + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p1);                    //  ,
  if (n1 > k1)                                  //  .
  {
    p1 += (k1 + 1);                             // .
    *p++ = (n1 -= k1);                          //  .
    do                                          //   .
      { *p++ = *p1++; }                         //  .
    while (--n1 != 0);                          //   .
  }
  else { *p++ = 1; *p = p1 [n1] >> (BITS-1); }  //  0  -1.
}

//               0-.
//
//         .

void    cBigNumberCutOut (                      // .
                const   EXPTR(long) p1,         //  .
                        size_t      k1,         //  .
                        size_t      n,          //  .
                        EXPTR(long) p           //   n1 + 1.
        )                                       // p1, p  .
{
  assert ((size_t)(*p1) >= k1 + n);             //  .
  *p++ = n + 1;                                 //  .
  if (n > 0)                                    //  .
  {
    p1 += (k1 + 1);                             // .
    do                                          //   .
      { *p++ = *p1++; }                         //  .
    while (--n != 0);                           //   .
  }
  *p = 0;                                       //  .
}

//================================================
//       .
//================================================

//              1.
//      1)        .
//      2)   .
//      3)    ,     100..(),
//            .
//               11..  100..(),
//            .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberNeg (                        //   p = -p1.
                const   EXPTR(long) p1,         //  .
                        EXPTR(long) p           //   *p1 + 2.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  p++;
  size_t n = n1;                                //  .
  if (n)
  do                                            //   .
  {
    long lp;                                    //  .
    if ((*p = lp = -*p1) != 0)                  //  .
    {                                           //   .
      if (--n != 0)                             //   ?
      {                                         //   :
        do                                      //  .
          { ++p1; ++p; *p = lp = ~*p1; }        //   .
        while (--n != 0);                       //   .
        return (n1 - (lp == (p[-1]>>(BITS-1))));//   ,
      }                                         //   .
                                                //    , 
      if (lp != LONG_MIN) return (n1);          //   
      p [1] = 0; return (n1 + 1);               //   .
    }
  }
  while ((++p1, ++p, --n) != 0);                //    .

  return (n1);                                  //   .
}
//#define cBigNumberNeg(p1,p)   (size_t)(*(p)=_cBigNumberNeg(p1,p))

//       1:
//      1)    1     .
//      2)    ,     100..(),
//            .
//               11..  100..(),
//            .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMInc (                       //  p1 = p1 + 1.
                        EXPTR(long) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .

  if (n)                                        //     .
  {
    do                                          //   1.
    {
      long lp;                                  //  .
      if ((*p1 = lp = *p1 + 1) != 0)            //  1.
      {                                         //   .
        if (--n != 0)                           //   ?
        {
          if (--n != 0) return (n1);            //   1 
          return (n1 - (p1[1]==(lp>>(BITS-1))));//   ,  .
        }                                       //    , 
        if (lp != LONG_MIN) return (n1);        //   
        p1 [1] = 0; return (n1 + 1);            //   .
      }
    }
    while ((++p1, --n) != 0);                   //    1.
  }
  else { *p1 = 1; n1 = 1; }                     //   .

  return (n1);                                  //   .
}
//#define cBigNumberMInc(p1)    (size_t)(*(p1)=_cBigNumberMInc(p1))

//       1:
//      1)    1    ,   ~0.
//      2)    ,     011..(),
//            .
//               00..  011..(),
//            .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMDec (                       //  p1 = p1 - 1.
                        EXPTR(long) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .

  if (n)                                        //     .
  {
    do                                          //   1.
    {
      long lp;                                  //  .
      if ((*p1 = lp = *p1 - 1) != ~0)           //  1.
      {                                         //   .
        if (--n != 0)                           //   ?
        {
          if (--n != 0) return (n1);            //   1 
          return (n1 - (p1[1]==(lp>>(BITS-1))));//   ,  .
        }                                       //    , 
        if (lp != LONG_MAX) return (n1);        //   
        p1 [1] = ~0; return (n1 + 1);           //   .
      }
    }
    while ((++p1, --n) != 0);                   //    1.
  }
  else { *p1 = -1; n1 = 1; }                    //   .

  return (n1);                                  //   .
}
//#define cBigNumberMDec(p1)    (size_t)(*(p1)=_cBigNumberMDec(p1))

//           
//            
//        ,   
//        .    
//         ,    
//       1, ..    .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMMul2 (                      //  p1 <<= 1.
                        EXPTR(long) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .
  long num = 0;                                 //   .
  if (n)
  do                                            //   .
  {
    long pass = (unsigned long)num >> (BITS-1); //    .
    num = *p1;                                  //    .
    *p1++ = (num << 1) | pass;                  //    .
  }
  while (--n != 0);                             //    .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p1 = num >> 1));              //  .

  return (n1);                                  //  .
}
//#define cBigNumberMMul2(p1)   (size_t)(*(p1)=_cBigNumberMMul2(p1))

//          .

size_t  _cBigNumberMul2 (                       //  p = p1 << 1.
                const   EXPTR(long) p1,         // .
                        EXPTR(long) p           //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  p++;
  long num = 0;                                 //   .
  size_t n = n1;                                //  .

  if (n)
  do                                            //   .
  {
    long pass = (unsigned long)num >> (BITS-1); //    .
    num = *p1++;                                //    .
    *p++ = (num << 1) | pass;                   //    .
  }
  while (--n != 0);                             //    .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p = num >> 1));               //  .

  return (n1);                                  //  .
}
//#define cBigNumberMul2(p1,p)  (size_t)(*(p)=_cBigNumberMul2(p1,p))

//           
//          .
//         ,  - .
//             ,
//          .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMDiv2 (                      //  p1 <<= 1.
                        EXPTR(long) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n = n1;                                //  .
  p1 += n;                                      //  .
  if (n)                                        //  ?
  {
    if (--n != 0)                               //   .
    {
      long num = *p1;                           //    .
      n1 -= (num == (*p1-- = (num >> 1)));      //     
                                                // ,  0  ~0.
      do                                        //   .
      {
        long pass = num << (BITS-1);            //    .
        num = *p1;                              //    .
        *p1-- = ((unsigned long)num>>1) | pass; //    .
      }
      while (--n != 0);                         //    .
    }
    else                                        //   .
    {
      (*p1) >>= 1;                              // .
    }
  }
  return (n1);                                  //  .
}
//#define cBigNumberMDiv2(p1)   (size_t)(*(p1)=_cBigNumberMDiv2(p1))

//          .

size_t  _cBigNumberDiv2 (                       //  p = p1 << 1.
                const   EXPTR(long) p1,         // .
                        EXPTR(long) p           //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n = n1;                                //  .
  p1 += n;                                      //  .
  p  += n;                                      //  .
  if (n)                                        //  ?
  {
    if (--n != 0)                               //   .
    {
      long num = *p1--;                         //    .
      n1 -= (num == (*p-- = (num >> 1)));       //     
                                                // ,  0  ~0.
      do                                        //   .
      {
        long pass = num << (BITS-1);            //    .
        num = *p1--;                            //    .
        *p-- = ((unsigned long)num>>1) | pass;  //    .
      }
      while (--n != 0);                         //    .
    }
    else                                        //   .
    {
      *p = (*p1) >> 1;                          // .
    }
  }
  return (n1);                                  //  .
}

//#define cBigNumberDiv2(p1,p)  (size_t)(*(p)=_cBigNumberDiv2(p1,p))

//================================================
//        .
//================================================

//          ,
//          (  1).

size_t  _cBigNumberFit  (                       // .
                        EXPTR(long) p1          //   .
        )                                       //     2.
{
  register size_t n1 = (size_t)(*p1);           //  .
  p1 += n1;                                     //  .
  register long pass;                           //  .
  register long lp;                             //  .

  if (n1)                                       //      
  {                                             //   
    lp = *p1;                                   //   0   1, 
    do continue;                                //   .
    while (--n1 != 0 &&
        (pass = lp, lp = p1 [-1], --p1, pass == (lp>>(BITS-1))));
  }                                             //     ,
  else { p1 [1] = 0; }                          //   .

  return (n1 + 1);                              //  .
}
//#define cBigNumberFit(p1)     (size_t)(*(p1)=_cBigNumberFit(p1))

//            
//      .      
//       ,      1.

size_t  _cBigNumberFitTo (                      // .
                        EXPTR(long) p1,         //   .
                        size_t n                //  .
        )                                       //    
{                                               // max(n+1,n1+2).
  register size_t n1 = (size_t)(*p1);           //  .
  register long pass = p1 [n1] >> (BITS-1);     // .

  do
  {
     p1 [++n1] = pass;                          //  .
  }
  while (n1 < n);

  return (n1);                                  //  .
}
//#define cBigNumberFitTo(p1,n) (size_t)(*(p1)=_cBigNumberFitTo(p1,n))

//================================================
//        .
//================================================

//       ,       
//          1..BITS-1   *p + 2.
//           
//       ;    
//          .
//            
//      ,   .

void    cBigNumberTab  (                        //   .
                        EXPTR(long) p           //    
        )                                       // (*p + 2) * BITS + 1
                                                //   
{                                               // p<<1..BITS-1   *p + 2.
  size_t n = cBigNumberFit (p);                 //   .
  int ns = BITS - 1;                            //   .
  p [n + 1] = p [n] >> (BITS-1);                //  .
  n += 2;
  EXPTR(long) pp = p;                           //  .
  do                                            //  .
  {
    pp += n;
    cBigNumberMul2 (p, pp);                     //    .
    p = pp;
  }
  while (--ns > 0);                             //    .
}

//================================================
//       .
//================================================

//          
//          .
//         .

//       :
//      - ,      .
//      -     .
//      -      
//            .

size_t  _cBigNumberXor  (                       //  mod 2 p = p1 ^ p2
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  assert (n1 >= n2);

  {
    register long lp2 = 0;                      //   p2;

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ ^ (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ ^ lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    register long pass;                         //  .
    register long lp;                           //  .
    register size_t n = n1;                     //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp>>(BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberXor(p1,p2,p) (size_t)(*(p)=_cBigNumberXor(p1,p2,p))

size_t  _cBigNumberAnd  (                       //  p = p1 & p2
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  assert (n1 >= n2);

  {
    register long lp2 = 0;                      //   p2;

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ & (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ & lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    register long pass;                         //  .
    register long lp;                           //  .
    register size_t n = n1;                     //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp>>(BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberAnd(p1,p2,p) (size_t)(*(p)=_cBigNumberAnd(p1,p2,p))

size_t  _cBigNumberOr  (                        //  p = p1 & p2
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  assert (n1 >= n2);

  {
    register long lp2 = 0;                      //   p2;

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ | (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ | lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    register long pass;                         //  .
    register long lp;                           //  .
    register size_t n = n1;                     //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp>>(BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberOr(p1,p2,p)  (size_t)(*(p)=_cBigNumberOr(p1,p2,p))

//================================================
//         .
//================================================

//          
//          .
//           
//           .
//
//       :
//      - ,      .
//      -     .
//      -      
//            .

size_t  _cBigNumberAdd  (                       //  p = p1 + p2
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  assert (n1 >= n2);

  register unsigned long pass = 0;              //     p.
        //      pass
        // unsigned long   pass >>   .
  {
    register long lp1 = 0;                      //   p1;
    register long lp2 = 0;                      //   p2;

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = *p1++; lp2 = *p2++;
          pass = (~(*p++ = (pass>>(BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                         | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//         p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        register const long *pp = p1;           // .
        if ((lp2 & LONG_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          p1, p2.
//           p    0  1.
//        p   pass.

    pass = (pass>>(BITS-1)) + ((lp1)>>(BITS-1)) + ((lp2)>>(BITS-1));
  }

//       -     p,   0  1
//             .

  {
    register long lp = *p;                      //  .
    register size_t n = n1;                     //  ,  .
    if (n && (long)pass == (lp>>(BITS-1)))      //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (long)pass == (lp>>(BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberAdd(p1,p2,p) (size_t)(*(p)=_cBigNumberAdd(p1,p2,p))

//          
//          .
//           
//           .
//
//       :
//      - ,      .
//      -     .
//      -      
//            .
//      -      :
//              .

size_t  _cBigNumberSub  (                       //  p = p1 - p2
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  assert (n1 >= n2);

  register unsigned long pass = ~0UL;           //     p.
        //      pass
        // unsigned long   pass >>   .
        //     .
  {
    register long lp1 = 0;                      //   p1;
    register long lp2 = ~0;                     //   ~p2;

//        p1, ~p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = *p1++; lp2 = ~(*p2++);
          pass = (~(*p++ = (pass>>(BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                         | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//         p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        register const long *pp = p1;           // .
        if ((lp2 & LONG_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          p1, p2~.
//           p    0  1.
//        p   pass.

    pass = (pass>>(BITS-1)) + ((lp1)>>(BITS-1)) + ((lp2)>>(BITS-1));
  }

//       -     p,   0  1
//             .

  {
    register long lp = *p;                      //  .
    register size_t n = n1;                     //  ,  .
    if (n && (long)pass == (lp>>(BITS-1)))      //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (long)pass == (lp>>(BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberSub(p1,p2,p) (size_t)(*(p)=_cBigNumberSub(p1,p2,p))

//         .

size_t  _cBigNumberSubS (                       //  p = p2 - p1
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         //  (  p1).
                        EXPTR(long) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n2 = (size_t)(*p2++);                  //  .
  p++;
  assert (n1 >= n2);

  register unsigned long pass = ~0UL;           //     p.
        //      pass
        // unsigned long   pass >>   .
        //     .
  {
    register long lp1 = ~0;                     //   ~p1;
    register long lp2 = 0;                      //   p2;

//        ~p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = ~(*p1++); lp2 = *p2++;
          pass = (~(*p++ = (pass>>(BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                         | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//         p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        register const long *pp = p1;           // .
        if ((lp2 & LONG_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = ~(*pp++);
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = ~(*pp++);
            pass = ~(*p++ = (pass>>(BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          ~p1, p2.
//           p    0  1.
//        p   pass.

    pass = (pass>>(BITS-1)) + ((lp1)>>(BITS-1)) + ((lp2)>>(BITS-1));
  }

//       -     p,   0  1
//             .

  {
    register long lp = *p;                      //  .
    register size_t n = n1;                     //  ,  .
    if (n && (long)pass == (lp>>(BITS-1)))      //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (long)pass == (lp>>(BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberSubS(p1,p2,p) (size_t)(*(p)=_cBigNumberSubS(p1,p2,p))

//================================================
//        
//          .
//================================================

//         .

static  size_t  _cBigNumberSkip = 0;            //  0- + 1.

size_t  cBigNumberSkipLow0 (                    //  0-.
                const   EXPTR(long) p1          //   .
)                                               //   0- + 1.
{
  size_t n1 = (size_t)(*p1);                    //   p1.
  size_t n = 1;                                 //  0- + 1.

  if (n1 != 0)
  do
  {
    if (p1 [n] != 0) break;                     //   .
    n++;
  }
  while (--n1 != 0);

  return _cBigNumberSkip = n;                   //  0- + 1.
}

#ifndef _CBIGNUM_ASM                            //   .

//           
//          .   .
//
//         , :
//      -     ,    
//         .
//      -       0.
//      -    ,    .
//           cBigNumberSkipLow0()
//          0-   .
//
//          ,  
//             .

void    cBigNumberMAddM (                       //  p1 += p2<<k2*BITS.
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2,         //   <=*p1-k2.
                        size_t k2               //   .
        )                                       // p1, p2  .
{
  const EXPTR(long) pp = p1 + (size_t)(*p1);    //   p1.
  size_t n2 = (size_t)(*p2);                    //   p2.
  assert (_cBigNumberSkip > 0);                 //  .
  assert ((size_t)(*p1) >= n2 + k2);            //  .
  assert (n2 >= _cBigNumberSkip);               // Check of size.
  p1 += k2;                                     //  p2.

//        p1, p2.
//          :
//      pass = ((~(*p1 = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
//                                                       | (lp1 & lp2))
//            :
//      pass += (lp1 + lp2)     // *p1 = pass
//      lp1  = ~(lp1 ^ lp2)     //  lp1  .
//      pass = ~(pass | lp1)    //    
//      pass |= (lp1 & lp2)     //   a & b = ~(a^b) & b.
//            
//           Pentium.

  register unsigned long pass = 0;              // : 0  1.
        // unsigned long   pass >>   .
  {
    const EXPTR(long) pp = p1 + n2;             //   p2.
    p1 += _cBigNumberSkip;                      //   p1.
    p2 += _cBigNumberSkip;                      //   p2.
    register long lp1;                          //   p1;
    register long lp2;                          //   p2;

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              //   p1, p2;
      pass += lp1;      lp1 ^= lp2;
      pass += lp2;      lp1 = ~lp1;
      *p1 = pass;       pass |= lp1;
      lp1 &= lp2;       pass = ~pass;
      ++p2;             pass |= lp1;
      if (p1 >= pp)     break;
      ++p1;             pass >>= (BITS-1);
    }
    if ((long)(lp2 ^= pass) >= 0) return;       //  .
  }

//         p1,  p1  p2.
//      : p1     ,
//                   pass     .
  {
    register long lp1;                          //   p1;
    if ((long)pass < 0)                         // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 + 1) & lp1) < 0);
    }
    else                                        // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 - 1) | lp1) >= 0);
    }
  }
}

//           
//         .   .
//
//         , :
//      -    .
//      -     ,    
//         .
//      -       0.
//      -        .
//      -      ,
//           .
//           cBigNumberSkipLow0()
//          0-  .
//
//            
//        .

size_t  _cBigNumberMSubD (                      //  p1 -= p2<<k2*BITS.
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2,         //   <=*p1-k2.
                        size_t k2               //   .
        )                                       // p1, p2  .
{
  size_t n2 = (size_t)(*p2);                    //   p2.
  assert (_cBigNumberSkip > 0);                 //  .
  assert ((p1 [(size_t)(*p1)] ^ p2 [n2]) >= 0); //  .
  assert ((size_t)(*p1) >= n2 + k2);            //  .
  assert (n2 >= _cBigNumberSkip);               // Check of size.
  p1 += k2;                                     //  p2.

//          :
//      pass = (((*p1 = (pass >> (BITS-1)) + lp1 - lp2) | (lp1 ^ lp2))
//                                                     & (~lp1 | lp2))
//            :
//      pass += (lp1 + lp2)     // *p1 = pass
//      pass += (lp1 ^= lp2)    //  lp1  .
//      pass &=~(lp1 & ~lp2)    //    
//                              //   a & ~b = (a^b) & ~b.
//            
//           Pentium.

  register long pass = 0;                       // : 0  -1.
        // long   pass >>   .
  {
    const EXPTR(long) pp = p1 + n2;             //   p2.
    p1 += _cBigNumberSkip;                      //   p1.
    p2 += _cBigNumberSkip;                      //   p2.
    register long lp1;                          //   p1;
    register long lp2;                          //   p2;

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              //   p1, p2;
      pass += lp1;      lp1 ^= lp2;
      pass -= lp2;      lp2 = ~lp2;
      *p1 = pass;       lp2 &= lp1;
      if (p1 >= pp)     break;
      lp2 = ~lp2;       pass |= lp1;
      ++p1;             pass &= lp2;
      ++p2;             pass >>= (BITS-1);
    }
  }

//       -     p,   0  1
//             .
//      : p1     ,
//                       pass.
  {
    register size_t n1 = n2 + k2;

//         :
//      do continue;
//      while (--n1 != 0 &&
//              lp1 == (lp1 = pass, pass = p1 [-1], --p1, pass >> (BITS-1)));

    for (;;)
    {
      register long lp1;                        //  .
      register long lp2;                        //  .
      if (--n1 == 0)    break;                  //   .
      lp2 = p1 [-1];    --p1;
      lp1 = pass;       pass = lp2;
      lp2 >>= (BITS-1);
      if (lp1 != lp2)   break;
    }
    return (n1 + 1);                            //   p.
  }
}
//#define cBigNumberMSubD(p1,p2,k2) (size_t)(*(p1)=_cBigNumberMSubD(p1,p2,k2))

//          1  ( 
//        .
//
//      ,     0.
//           cBigNumberSkipLow0()
//          0-  .
//
//           
//            
//        ,   
//        .    
//         ,    
//       1, ..    .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMMul2M (                     //  p1 <<= 1.
                        EXPTR(long) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  assert (_cBigNumberSkip > 0);                 //  .
  assert (n1 >= _cBigNumberSkip);               //  .

  const EXPTR(long) pp = p1 + n1;               //   p1.
  p1 += _cBigNumberSkip;                        //    p1.
  long num = 0;                                 //   .
  do                                            //   .
  {
    long pass = (unsigned long)num >> (BITS-1); //    .
    num = *p1;                                  //    .
    *p1++ = (num << 1) | pass;                  //    .
  }
  while (p1 <= pp);                             //   .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p1 = num >> 1));              //  .

  return (n1);                                  //  .
}
//#define cBigNumberMMul2M(p1)   (size_t)(*(p1)=_cBigNumberMMul2M(p1))

//          1 .
//            .
//
//      , :
//      -    0.
//      -      .
//           cBigNumberSkipLow0()
//          0-  .
//
//           
//          .
//         ,  - .
//             ,
//          .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMDiv2D (                     //  p1 >>= 1.
                        EXPTR(long) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  assert (_cBigNumberSkip > 0);                 //  .
  assert (n1 >= _cBigNumberSkip);               //  .
  assert ((p1 [_cBigNumberSkip] & 1L) == 0);    //   .

  const EXPTR(long) pp = p1 + _cBigNumberSkip;  //    p1.
  p1 += n1;                                     //  .
  long num = *p1;                               //    .
  n1 -= (n1 > 1) & (num == (*p1-- = num >> 1)); //     
                                                // ,  0  ~0.
  while (p1 >= pp)                              //   .
  {
    long pass = num << (BITS-1);                //    .
    num = *p1;                                  //    .
    *p1-- = ((unsigned long)num >> 1) | pass;   //    .
  }                                             //    .

  return (n1);                                  //  .
}
//#define cBigNumberMDiv2D(p1)   (size_t)(*(p1)=_cBigNumberMDiv2D(p1))

#endif//_CBIGNUM_ASM

//              .
//         ,  ,  .

void    cBigNumberMShrM (                       //  p1>>=BITS.
                        EXPTR(long) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  assert (n1 > 1);                              // .
  *p1 = --n1;
  do                                            //   .
    { p1 [1] = p1 [2]; p1++; }                  //  .
  while ((int)--n1 > 0);                        //   .
}

//             .
//         ,  ,  .

void    cBigNumberMShlD (                       //  p1<<=BITS.
                        EXPTR(long) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  assert (n1 > 0);                              // .
  *p1  = n1 + 1;
  do                                            //   .
    { p1 [n1 + 1] = p1 [n1]; }                  //  .
  while ((int)--n1 > 0);                        //   .
  p1 [1] = 0;
}

//================================================
//       .
//================================================

static  cBigNumber   cBigBuf1;  // .
static  cBigNumber   cBigBuf2;  // , , .
static  cBigNumber   cBigBuf3;  //  .
static  cBigNumber   cBigBuf4;  //   .

//================================================
//       .
//================================================

//          .
//       c,      .
//
//       ,   ,
//      ..   ,   .
//
//             
//       .

void    cBigNumberMAddMulShl (                  //  p+=p1*p2<<k*BITS.
                        EXPTR(long) p1,         //    
                                                // *p1 + 2, .
                const   EXPTR(long) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(long) p           //    
                                                // max (*p1 + *p2 + k, *p) + 2.
        )                                       // p1,p2,p   .
{
  assert (_cBigNumberSkip == 0);                //  .
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//       ,    .

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) //  ?
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //    p2.
    {
      long num = p2 [k2 + 1];                   //   p2.
      if (num == 0) continue;                   // .
      long mask = 1;                            //    num.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
      cBigNumberMMul2M (p1);                    //    .
      cBigNumberMShrM (p1);                     //  .
    }                                           //     p2.
    {
      long num = p2 [k2 + 1];                   //   p2.
      long mask = (num != 0);                   //    num.
      if (num > 0)                              //   num 
      do                                        //   0  pp2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  //   num  0.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }
  }
  cBigNumberFit (p);                            // .
  EXDEBUG (_cBigNumberSkip = 0);                //  .
}

//           .
//      ,     
//       ,   cBigNumberTab().
//
//       ,   ,
//      ..   ,   .
//
//             
//       .

void    cBigNumberMAddMulTab (                  //  p+=p1*p2<<k*BITS.
                const   EXPTR(long) p1,         //    .
                const   EXPTR(long) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(long) p           //    
                                                // max (*p1 + *p2 + k, *p) + 2.
        )                                       // p1, p2  .
{
  assert (_cBigNumberSkip == 0);                //  .
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//          .

  if (n1 >= cBigNumberSkipLow0 (p1))            //  .
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    n1 += 2;                                    //   .
    for (size_t k2 = 0; k2 != n2; k2++)         //    p2.
    {
      long num = p2 [k2 + 1];                   //   p2.
      long mask = 1;                            //    num.
      const EXPTR(long) pp1 = p1;               //  .
      for (;; pp1 += n1)                        //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }                                           //     p2.
  }

  cBigNumberFit (p);                            // .
  EXDEBUG (_cBigNumberSkip = 0);                //  .
}

//            
//             
//        .    ,
//            , 
//       ,    .
//
//             
//       .

void    cBigNumberMAddMul (                     //  p += p1 * p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         // .
                        EXPTR(long) p           //    
                                                // max (*p1 + *p2 + 3, *p + 2).
        )                                       // p1, p2, p  .
{
  assert (_cBigNumberSkip == 0);                //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

  cBigBuf1.checkexpand ((n2 <= SHIFT_TAB_MIN)? (n1 + 3):
                        (n1 < SHIFT_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                  size_max (n1 + 3, (SHIFT_TAB_HIGH + 3) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(long) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   .

  if (p2 [n2] >= 0)                             //  :
  {                                             // .
    cBigNumberCopy (p1, pp1);
    cBigNumberCopy (p2, pp2);
  }
  else                                          //  :
  {                                             //  .
    cBigNumberNeg  (p1, pp1);
    cBigNumberNeg  (p2, pp2);
    assert (pp2 [(size_t)(*pp2)] >= 0);         //  .
    *pp2 = n2;                                  //    
  }                                             //   LONG_MIN.

//         .

  if (n2 > SHIFT_TAB_MIN)
  {
    size_t k = 0;                               //   .
    if (k + (SHIFT_TAB_HIGH) < n1)
    {
      cBigBuf3.checkexpand ((SHIFT_TAB_OPT + 3) * BITS + 1);
      EXPTR(long) pp3 = EXPTRTYPE(cBigBuf3);
      do                                        //   .
      {
        cBigNumberCutOut (pp1, k, SHIFT_TAB_OPT, pp3);
        cBigNumberTab (pp3);                    //   .
        cBigNumberMAddMulTab (pp3, pp2, k, p);  //  .
        k += SHIFT_TAB_OPT;
      }
      while (k + (SHIFT_TAB_HIGH) < n1);
      cBigNumberCopyShr (pp1, k, pp1);          //  .
    }
    cBigNumberTab (pp1);                        //   .
    cBigNumberMAddMulTab (pp1, pp2, k, p);      // .
    EXDEBUG (cBigBuf1 = 0);                     //  .
    EXDEBUG (cBigBuf2 = 0);                     //  .
    EXDEBUG (cBigBuf3 = 0);                     //  .
    EXDEBUG (_cBigNumberSkip = 0);              //  .
    return;
  }

//      ,    .

  if (n1 >= cBigNumberSkipLow0 (pp1) && n2 != 0)//  ?
  {
    cBigNumberFitTo (p, n1 + n2 + 1);           // .
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //    p2.
    {
      long num = pp2 [k2 + 1];                  //   p2.
      if (num == 0) continue;                   // .
      long mask = 1;                            //    num.
      for (;; cBigNumberMMul2M (pp1))           //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
      cBigNumberMMul2M (pp1);                   //    .
      cBigNumberMShrM (pp1);                    //  .
    }                                           //     p2.
    {
      long num = pp2 [k2 + 1];                  //   p2.
      long mask = (num != 0);                   //    num.
      if (num > 0)                              //   num 
      do                                        //   0  pp2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  //   num  0.
      for (;; cBigNumberMMul2M (pp1))           //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }
  }
  cBigNumberFit (p);                            // .
  EXDEBUG (cBigBuf1 = 0);                       //  .
  EXDEBUG (cBigBuf2 = 0);                       //  .
  EXDEBUG (cBigBuf3 = 0);                       //  .
  EXDEBUG (_cBigNumberSkip = 0);                //  .
}

//            
//             
//        .    ,
//            , 
//       ,    .
//
//             
//       .

void    cBigNumberMul (                         //  p = p1 * p2.
                const   EXPTR(long) p1,         // .
                const   EXPTR(long) p2,         // .
                        EXPTR(long) p           //   *p1 + *p2 + 3.
        )                                       // p1, p2, p  .
{
  assert (_cBigNumberSkip == 0);                //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

  cBigBuf1.checkexpand ((n2 <= SHIFT_TAB_MIN)? (n1 + 3):
                        (n1 < SHIFT_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                  size_max (n1 + 3, (SHIFT_TAB_HIGH + 3) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                //  ,
  EXPTR(long) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   .

  if (p2 [n2] >= 0)                             //  :
  {                                             // .
    cBigNumberCopy (p1, pp1);
    cBigNumberCopy (p2, pp2);
  }
  else                                          //  :
  {                                             //  .
    cBigNumberNeg  (p1, pp1);
    cBigNumberNeg  (p2, pp2);
    assert (pp2 [(size_t)(*pp2)] >= 0);         //  .
    *pp2 = n2;                                  //    
  }                                             //   LONG_MIN.

//        -    cBigNumberMul
//       cBigNumberMAddMul.     
//      ,    .

  p [0] = 0;                                    //  .

//         .

  if (n2 > SHIFT_TAB_MIN)
  {
    size_t k = 0;                               //   .
    if (k + (SHIFT_TAB_HIGH) < n1)
    {
      cBigBuf3.checkexpand ((SHIFT_TAB_OPT + 3) * BITS + 1);
      EXPTR(long) pp3 = EXPTRTYPE(cBigBuf3);
      do                                        //   .
      {
        cBigNumberCutOut (pp1, k, SHIFT_TAB_OPT, pp3);
        cBigNumberTab (pp3);                    //   .
        cBigNumberMAddMulTab (pp3, pp2, k, p);  //  .
        k += SHIFT_TAB_OPT;
      }
      while (k + (SHIFT_TAB_HIGH) < n1);
      cBigNumberCopyShr (pp1, k, pp1);          //  .
    }
    cBigNumberTab (pp1);                        //   .
    cBigNumberMAddMulTab (pp1, pp2, k, p);      // .
    EXDEBUG (cBigBuf1 = 0);                     //  .
    EXDEBUG (cBigBuf2 = 0);                     //  .
    EXDEBUG (cBigBuf3 = 0);                     //  .
    EXDEBUG (_cBigNumberSkip = 0);              //  .
    return;
  }

//      ,    .

  if (n1 >= cBigNumberSkipLow0 (pp1) && n2 != 0)//  ?
  {
    cBigNumberFitTo (p, n1 + n2 + 1);           // .
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //    p2.
    {
      long num = pp2 [k2 + 1];                  //   p2.
      if (num == 0) continue;                   // .
      long mask = 1;                            //    num.
      for (;; cBigNumberMMul2M (pp1))           //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
      cBigNumberMMul2M (pp1);                   //    .
      cBigNumberMShrM (pp1);                    //  .
    }                                           //     p2.
    {
      long num = pp2 [k2 + 1];                  //   p2.
      long mask = (num != 0);                   //    num.
      if (num > 0)                              //   num 
      do                                        //   0  pp2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  //   num  0.
      for (;; cBigNumberMMul2M (pp1))           //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }
  }
  cBigNumberFit (p);                            // .
  EXDEBUG (cBigBuf1 = 0);                       //  .
  EXDEBUG (cBigBuf2 = 0);                       //  .
  EXDEBUG (cBigBuf3 = 0);                       //  .
  EXDEBUG (_cBigNumberSkip = 0);                //  .
}

//================================================
//      ,    0.
//================================================

size_t  cBigNumberMaskDiv0;                     //    0:
                                                //  0 - Divide Error
void    cBigNumberDiv0 (void)                   // >0 - 
{
  cBigNumberMaskDiv0 /= cBigNumberMaskDiv0;
}

//================================================
//        .
//================================================

//           .
//      ,     
//         ,     
//       ,   cBigNumberTab.
//
//              .
//       >= 0.      .
//            .

void    cBigNumberMModDivTab (                  //  p = p1/p2, p1 %= p2
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2,         //    .
                        EXPTR(long) p           //   *p1 + 2.
        )                                       // p1,p2,p   .
{
  assert (_cBigNumberSkip == 0);                //  .
  assert (cBigNumberIsFit (p1));                //  .
  assert (cBigNumberIsFit (p2));                //  .
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .
  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;       //    .

//              ,
//             .
//          ,    
//       .

  *p = n + 1; p += n; p [1] = 0;                //   p.

//        .

  cBigNumberSkipLow0 (p2);                      //   0-.
  if (cBigNumberNot0 (p2))                      //    0.
  {
    assert ((p1 [n1] ^ p2 [n2]) >= 0);          //  .
    long lt = (p1 [n1] < 0) * 2 - 1;            //   
                                                //   .
                                                // (p1 >= 0)? -1: 1
    const EXPTR(long) pp2 = p2;                 //  .
    n2 += 2;                                    //   .
    do                                          //    .
    {
      --n;                                      //   .
      pp2 += n2 * BITS;                         //    .
      unsigned long mask = (unsigned long)
                           (1L << (BITS-1));    //  .
      *p = 0;                                   //   .
      do                                        //    .
      {
        pp2 -= n2;                              //  .
        assert (*pp2 >= (long)(n2 - 2) && *pp2 <  (long) n2);
                                                //   ?
        int diff = n - (size_t)(*p1)            //  .
                     + (size_t)(*pp2);
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, pp2) != lt))//  ,
        {                                       //  
          cBigNumberMSubD (p1, pp2, n);         //   
          (*p) += mask;                         //   .
        }
      }
      while ((mask >>= 1) != 0);                //    .
      --p;                                      //   .
    }
    while (n);                                  //    .
    assert (cBigNumberComp (p1, pp2) == lt);    //   ?
  }
  else                                          //   0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
    do { *p-- = 0; } while (--n);               //   .
  }
  cBigNumberFit (p);                            //  .
  assert (p [(size_t)(*p)] >= 0);               //  .
  EXDEBUG (_cBigNumberSkip = 0);                //  .
}

//              
//            .
//         ,      
//      ,   ,    .
//
//              .
//        -      .
//           .
//
//             
//         .

void    cBigNumberMModDiv (                     //  p = p1/p2, p1 %= p2
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2,         // .
                        EXPTR(long) p           //   *p1 + 3.
        )                                       // p2    p1, p.
{
  assert (_cBigNumberSkip == 0);                //  .
  assert (p1 != p);                             //  .

//         :  
//          .

  size_t n1 = (size_t) cBigNumberFit (p1);      //  .
  size_t n2 = (size_t)(*p2);                    //  .
  int nt = (int) ((SHIFT_TAB_MIN + n2 - n1) & (n1 - SHIFT_TAB_MAX));

  cBigBuf2.checkexpand ((nt < 0)? ((n2 + 3) * BITS + 1): (n2 + 3));
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   .

  long signdiv;                                 //   .
  if ((p1 [n1] ^ p2 [n2]) >= 0)                 //  :
    { cBigNumberCopy (p2, pp2); signdiv = 1; }  //  .
  else                                          //   :
    { cBigNumberNeg (p2, pp2); signdiv = -1; }  //   .

//         .

  if (nt < 0)
  {
    cBigNumberTab (pp2);                        //   .
    cBigNumberMModDivTab (p1, pp2, p);          // .
    if (signdiv < 0) cBigNumberNeg (p, p);      //  .
    EXDEBUG (cBigBuf2 = 0);                     //  .
    EXDEBUG (_cBigNumberSkip = 0);              //  .
    return;
  }

//      ,    .

  n2 = cBigNumberFit (pp2);                     //  .
  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;       //    .

//              ,
//             .
//          ,    
//       .

  *p = n + 1; p += n; p [1] = 0;                //   p.

//        .

  cBigNumberSkipLow0 (pp2);                     //   0-.
  if (cBigNumberNot0 (pp2))                     //    0.
  {
    assert ((p1 [n1] ^ pp2 [n2]) >= 0);         //   .
    long lt = (p1 [n1] < 0) * 2 - 1;            //   
                                                //   
                                                // (p1 >= 0)? -1: 1
    do                                          //    .
    {
      --n;                                      //   .
      *p = 0;                                   //   .
      cBigNumberMShlD (pp2);                    //    .
      unsigned long mask = (1UL << (BITS-1));   //  .
      do                                        //    .
      {
        int diff = cBigNumberMDiv2D (pp2) + n - //    .
                   (size_t)(*p1);               //  .
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, pp2) != lt))//  ,
        {                                       //  
          cBigNumberMSubD (p1, pp2, n);         //   
          (*p) += mask;                         //   .
        }
      }
      while ((mask >>= 1) != 0);                //    .
      --p;                                      //   .
    }
    while (n);                                  //    .
    assert (cBigNumberComp (p1, pp2) == lt);    //   ?
  }
  else
  {                                             //    0
    cBigNumberDiv0();                           // ,  
    do { *p-- = 0; } while (--n);               //   .
  }
  cBigNumberFit (p);                            //  .
  assert (p [(size_t)(*p)] >= 0);               //  .
  if (signdiv < 0) cBigNumberNeg (p, p);        //  .
  EXDEBUG (cBigBuf2 = 0);                       //  .
  EXDEBUG (_cBigNumberSkip = 0);                //  .
}

//================================================
//        .
//================================================

//           .
//      ,     
//         ,     
//       ,   cBigNumberTab.
//
//           
//       ,     .
//           .
//           .
//
//          .

void    cBigNumberMModTab (                     //  p1 %= p2.
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2          //    .
        )                                       // p1, p2   .
{
  assert (_cBigNumberSkip == 0);                //  .
  assert (cBigNumberIsFit (p1));                //  .
  assert (cBigNumberIsFit (p2));                //  .
  assert (p1 != p2);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .
  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;       //    .

  cBigNumberSkipLow0 (p2);                      //   0-.
  if (cBigNumberNot0 (p2))                      //    0.
  {
    assert ((p1 [n1] ^ p2 [n2]) >= 0);          //  .
    long lt = (p1 [n1] < 0) * 2 - 1;            //   
                                                //   
                                                // (p1 >= 0)? -1: 1
    const EXPTR(long) pp2 = p2;                 //  .
    n2 += 2;                                    //   .
    do                                          //    .
    {
      --n;                                      //   .
      pp2 += n2 * BITS;                         //    .
      unsigned long mask = (1UL << (BITS-1));   //  .
      do                                        //    .
      {
        pp2 -= n2;                              //  .
        assert (*pp2 >= (long)(n2 - 2) && *pp2 <  (long) n2);
                                                //   ?
        int diff = n - (size_t)(*p1)            //  .
                     + (size_t)(*pp2);
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, pp2) != lt))//  ,
        {                                       //  
          cBigNumberMSubD (p1, pp2, n);         //  .
        }
      }
      while ((mask >>= 1) != 0);                //    .
    }
    while (n);                                  //    .
    assert (cBigNumberComp (p1, pp2) == lt);    //   ?
  }
  else                                          //   0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
  }                                             //   .
  EXDEBUG (_cBigNumberSkip = 0);                //  .
}

//              
//            .
//         ,      
//      ,   ,    .
//
//           
//       ,     .
//           .
//           .
//
//             
//       .

void    cBigNumberMMod (                        //  p1 %= p2.
                        EXPTR(long) p1,         // ,  .
                const   EXPTR(long) p2          // .
        )                                       // p1, p2  .
{
  assert (_cBigNumberSkip == 0);                //  .

//         :  
//          .

  size_t n1 = (size_t) cBigNumberFit (p1);      //  .
  size_t n2 = (size_t)(*p2);                    //  .
  int nt = (int) ((SHIFT_TAB_MIN + n2 - n1) & (n1 - SHIFT_TAB_MAX));

  cBigBuf2.checkexpand ((nt < 0)? ((n2 + 3) * BITS + 1): (n2 + 3));
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   .

  if ((p1 [n1] ^ p2 [n2]) >= 0)                 //  :
    { cBigNumberCopy (p2, pp2); }               //  .
  else                                          //   :
    { cBigNumberNeg  (p2, pp2); }               //   .

//         .

  if (nt < 0)
  {
    cBigNumberTab (pp2);                        //   .
    cBigNumberMModTab (p1, pp2);                // .
    EXDEBUG (cBigBuf2 = 0);                     //  .
    EXDEBUG (_cBigNumberSkip = 0);              //  .
    return;
  }

//      ,    .

  n2 = cBigNumberFit (pp2);                     //  .
  size_t n = ((n1 > n2)? n1 - n2: 0) + 1;       //    .
  cBigNumberSkipLow0 (pp2);                     //   0-.
  if (cBigNumberNot0 (pp2))                     //    0.
  {
    assert ((p1 [n1] ^ pp2 [n2]) >= 0);         //   .
    long lt = (p1 [n1] < 0) * 2 - 1;            //   
                                                //   .
                                                // (p1 >= 0)? -1: 1
    do                                          //    .
    {
      --n;                                      //   .
      cBigNumberMShlD (pp2);                    //    .
      unsigned long mask = (1UL << (BITS-1));   //  .
      do                                        //    .
      {
        int diff = cBigNumberMDiv2D (pp2) + n - //    .
                   (size_t)(*p1);               //  .
        if (diff <= 0 && (diff < 0 ||           //    
            cBigNumberCompHigh (p1, pp2) != lt))//  ,
        {                                       //  
          cBigNumberMSubD (p1, pp2, n);         //  .
        }
      }
      while ((mask >>= 1) != 0);                //    .
    }
    while (n);                                  //    .
    assert (cBigNumberComp (p1, pp2) == lt);    //   ?
  }
  else                                          //   0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
  }                                             //   .
  EXDEBUG (cBigBuf2 = 0);                       //  .
  EXDEBUG (_cBigNumberSkip = 0);                //  .
}

//================================================
//         .
//================================================

//            ,
//         ,      , 
//       .       
//             .
//      ,    p2     p1 
//       -1,0,1,      512 M.
//
//          .
//
//             
//       .

void    cBigNumberPow (                         //  p1   p2.
                        EXPTR(long) p1,         //   .
                const   EXPTR(long) p2,         //  >= 0.
                        EXPTR(long) p           //   .
        )                                       // p1,p2,p   .
{                                               // p1 .
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n2 = (size_t)(*p2);                    //  .
  assert (p2 [n2] >= 0);                        //  .
  p2++;                                         // .

  p [0] = 1; p [1] = 1;                         //  .

  if (n2 != 0)                                  //   ?
  {
    for (;;)                                    //    p2.
    {
      long num = *p2++;                         //   p2.
      long mask = 1;                            //    num.
      if (--n2 == 0)                            //   
      {                                         //   .
        if (num == 0) break;                    //   p2 .
        do                                      //   num  0.
          mask <<= 1;                           //  mask  num, 
        while ((num <<= 1) > 0);                //   num  0.
      }
      for (;;)                                  //     p2.
      {
        if (num & mask)
          cBigNumberMul (p1, p, p);             //  .
        if ((mask <<= 1) == 0) break;           //  .
        cBigNumberMul (p1, p1, p1);             //  .
      }                                         //     p2.
      if (n2 == 0) break;                       //  .
      cBigNumberMul (p1, p1, p1);               //  .
    }                                           //     p2.
  }
}

//             
//             ,
//              .
//
//          ,  - 
//      (  0    0 ,    1).
//
//             
//       .

void    cBigNumberPowMod (                      //  p1   p2.
                        EXPTR(long) p1,         //    
                                                // max (*p1, *mod * 2) + 2.
                const   EXPTR(long) p2,         //  >= 0.
                const   EXPTR(long) mod,        //  ( ).
                        EXPTR(long) p           //    
                                                // *mod * 2 + 2.
        )                                       // p1,p2,p   .
{                                               // p1 .
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n2 = (size_t)(*p2);                    //  .
  assert (p2 [n2] >= 0);                        //  .
  p2++;                                         // .
  size_t nmod = (size_t)(*mod);                 //  .

  cBigBuf4.checkexpand (exmuladd (BITS, nmod, BITS * 3 + 1));
  EXPTR(long) pmod = EXPTRTYPE(cBigBuf4);       //   .

//            .

  if (mod [nmod] >= 0)                          //  .
    { cBigNumberCopy (mod, pmod); }             //  .
  else
    { cBigNumberNeg  (mod, pmod); }             //   .

  cBigNumberTab (pmod);                         //   .
  if (cBigNumberNot0 (pmod) == 0) n2 = 0;       //   0.

//       .

  p [0] = 1; p [1] = 1;                         //  .
  cBigNumberMModTab (p, pmod);                  //  .

  if (n2 != 0 && p [1] != 0)                    //   ?
  {

//          (    ).

    long sign = p1 [(size_t)(*p1)];             //  .
    if (sign < 0)
    {
      cBigNumberNeg (p1, p1);                   //   .
      assert (p1 [(size_t)(*p1)] >= 0);         //  .
      sign = (*p2 << (BITS-1));                 //  .
    }
    cBigNumberMModTab (p1, pmod);               //  .

//          .

    for (;;)                                    //    p2.
    {
      long num = *p2++;                         //   p2.
      long mask = 1;                            //    num.
      if (--n2 == 0)                            //   
      {                                         //   .
        if (num == 0) break;                    //   p2 .
        do                                      //   num  0.
          mask <<= 1;                           //  mask  num, 
        while ((num <<= 1) > 0);                //   num  0.
      }
      for (;;)                                  //     p2.
      {
        if (num & mask)
        {                                       //  .
          if (*p1 > *p) cBigNumberMul (p1, p, p);
          else          cBigNumberMul (p, p1, p);
          cBigNumberMModTab (p, pmod);          //  .
        }
        if ((mask <<= 1) == 0) break;           //  .
        cBigNumberMul (p1, p1, p1);             //  .
        cBigNumberMModTab (p1, pmod);           //   .
      }                                         //     p2.
      if (n2 == 0) break;                       //  .
      cBigNumberMul (p1, p1, p1);               //  .
      cBigNumberMModTab (p1, pmod);             //   .
    }                                           //     p2.
    if (sign < 0) cBigNumberNeg (p, p);         //  .
  }

  EXDEBUG (cBigBuf4 = 0);                       //  .
}

//================================================
//         .
//================================================

//          
//           .
//
//             
//          .

void    cBigNumberMRmSqrt (                     //  .
                        EXPTR(long) p1,         // ,  .
                        EXPTR(long) p           //   *p1/2 + 2.
        )                                       // p1, p   .
{
  assert (_cBigNumberSkip == 0);                //  .
  assert (p1 != p);                             //  .

//       .

  size_t n1 = (size_t) cBigNumberFit (p1);      //  .
  assert (p1 [n1] >= 0);                        // .

  cBigBuf2.checkexpand (n1 + 1);                // +1   .
  EXPTR(long) pp2 = EXPTRTYPE(cBigBuf2);        //   .
  *pp2 = 0;                                     // .
  cBigNumberFitTo (pp2, n1);                    // .

//      .

  int nbit = (cBigNumberBits (p1) + 1) & ~1;
  if (nbit < 0) cBigNumberERange (p1);
  if ((nbit -= 2) >= 0)
  {

//         .

    {
      size_t nw = nbit / BITS;                  // .
      long lw = (1L<<(nbit % BITS));            // .
      pp2 [nw + 1] += lw;                       //  .
      assert (pp2 [(size_t)(*pp2)] >= 0);       // .
      p1  [nw + 1] -= lw;                       //   .
      assert (p1  [(size_t)(*p1)]  >= 0);       // .
    }

//         .
//           ,  
//          .

    while ((nbit -= 2) >= 0)                    //    .
    {
      size_t nw = nbit / BITS;                  // .
      long lw = (1L<<(nbit % BITS));            // .
      pp2 [nw + 1] += lw;                       //  .
      _cBigNumberSkip = nw + 1;                 //  .
      if (cBigNumberComp (p1, pp2) < 0)         // .
      {
        pp2 [nw + 1] -= lw;                     //  .
        cBigNumberMDiv2D (pp2);                 //    .
      }
      else
      {
        cBigNumberMSubD (p1, pp2, 0);           //  .
        assert (p1 [(size_t)(*p1)] >= 0);       // .
        assert (cBigNumberIsFit (p1));          // .
        pp2 [nw + 1] -= lw;                     //  .
        cBigNumberMDiv2D (pp2);                 //    .
        pp2 [nw + 1] += lw;                     //  .
      }
      assert (pp2 [(size_t)(*pp2)] >= 0);       // .
      assert (cBigNumberIsFit (pp2));           // .
    }
  }
  cBigNumberFit (pp2);                          //  .
  cBigNumberCopy (pp2, p);                      //  .

//      ,      ,
//           .

  assert (cBigNumberComp (
    (_cBigNumberSkip = 1, cBigNumberMMul2M (pp2), pp2), p1) >= 0);

  EXDEBUG (_cBigNumberSkip = 0);                //  .
}

#ifdef  __cplusplus
}
#endif//__cplusplus
